/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is XulApp IDE.
 *
 * The Initial Developer of the Original Code is Synesis Software (USA) Inc.
 *

 * Portions created by the Initial Developer are Copyright (C) 2001-2005
 * Synesis Software (USA) Inc. the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * 	Peter Wilson, orignal author.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the LGPL or the GPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 *
 * ***** END LICENSE BLOCK ***** */
 
netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");

const DEBUG = false;
/*
	var fileURI = "chrome://xulapp/content/resource/tools.xml"
	var file = new File(fileURI);
	file.open("r");
	var src = file.read();
	var parser = new DOMParser();
	var dom = parser.parseFromString(src, "text/xml");

	var DS = new DOMDatasource(dom, fileURI);
	
	var tree1 = document.getElementById("tree1");
	tree1.database.AddDataSource(DS);
	tree1.ref = "urn:root";
	tree1.builder.rebuild();
*/

/** XML 
*	<A xmlns="xyz" id="A1" a="aaaa1">
*  	<B id= "B1" b="bbb1"/>	
*  	<B id= "B2" b="bbbc"/>
*		<C>cxcxcx</cx>
*	</A>
*	Encoded as:
* 	Element A:  xyz#A1
*		attribute a of A: xzy/A:a
* 	Element B:  xyz#B1 or xyz#B2
*		attribute b of B1: xzy/B::b
*		attribute b of B2: xzy/B::b
*  Element C:
*		xyz/A/C
*		text content xyz/A/C::@text
*/
var RDF = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
const RS = "http://www.w3.org/1999/02/22-rdf-syntax-ns#"
const RS_INSTANCEOF = RDF.GetResource(RS + "instanceOf");
const RS_SEQ = RDF.GetResource(RS + "Seq");
const RS_BAG = RDF.GetResource(RS + "Bag");
const RS_ALT = RDF.GetResource(RS + "Alt");
const RS_NEXTVAL = RDF.GetResource(RS + "nextVal");
const RS_TYPE = RDF.GetResource(RS + "type");
const NC = "http://home.netscape.com/NC-rdf#"
const NC_CHILD = RDF.GetResource(NC + "child");
const NC_BOOKMARKSEPARATOR = RDF.GetResource(NC + "BookmarkSeparator");

// RDF-specific success nsresults 
//
const NS_ERROR_RDF_BASE = 0x804f0000; // XXX is this right?
const NS_RDF_CURSOR_EMPTY = NS_ERROR_RDF_BASE + 1;
//const NS_RDF_NO_VALUE = NS_ERROR_RDF_BASE + 2;
//const NS_RDF_ASSERTION_ACCEPTED = Components.results.NS_OK;
//const NS_RDF_ASSERTION_REJECTED = NS_ERROR_RDF_BASE + 3;

function DOMDatasource(dom, fileURI) {
	this.URI = fileURI;
	this.namespaceURI = dom.documentElement.namespaceURI;
	this.dom = dom;
	if (DEBUG) debug("fileURI:" + this.URI + "nsURI:" + this.namespaeURI);
}
/** Find an RDF resource that points to a given node over the
* specified arc & truth value
*
* @return NS_RDF_NO_VALUE if there is no source that leads
* to the target with the specified property.
*/
DOMDatasource.prototype.GetSource = function(propertyRes, targetNode, truthValue) {
	if (DEBUG) debug("GetSource() called with args: \n\t" + aProperty.Value + 
		 "\n\t" + aTarget.Value + "\n\t" + truthValue + "\n\n");

	Components.returnCode = NS_RDF_NO_VALUE;
	return null;
}
/**
* Find all RDF resources that point to a given node over the
* specified arc & truth value
*
* @return NS_OK unless a catastrophic error occurs. If the
* method returns NS_OK, you may assume that nsISimpleEnumerator points
* to a valid (but possibly empty) cursor.
*/
DOMDatasource.prototype.GetSources = function(propertyRes, targetNode, truthValue) {
	if (DEBUG) debug("GetSources() called with args: \n\t" + aProperty.Value + 
	 "\n\t" + aTarget.Value + "\n\t" + truthValue + "\n\n");
	return new XMLNullEnumerator();
}
/**
* Find a child of that is related to the source by the given arc
* arc and truth value
*
* @return NS_RDF_NO_VALUE if there is no target accessable from the
* source via the specified property.
*/
DOMDatasource.prototype.GetTarget = function(sourceRes, propertyRes, truthValue) {
	if (DEBUG) debug("GetTarget() called with args: \n\t" + sourceRes.Value + 
	 "\n\t" + propertyRes.Value + "\n\t" + truthValue + "\n\n");
	var elem = this.getElement(sourceRes.Value);
	if (!elem) {
		Components.returnCode = NS_RDF_NO_VALUE;
		return null;
	}	
	if (propertyRes.EqualsNode(RS_NEXTVAL)) {
		return RDF.GetIntLiteral(this.countChildren(elem) + 1);
	}
	var attrVal = this.getAttribute(elem, propertyRes.Value);	
	if (!attrVal) {
		Components.returnCode = NS_RDF_NO_VALUE;
		return null;
	}	
	return RDF.GetLiteral(attrVal);	
		
}
/**
* Find all children of that are related to the source by the given arc
* arc and truth value.
*
* @return NS_OK unless a catastrophic error occurs. If the
* method returns NS_OK, you may assume that nsISimpleEnumerator points
* to a valid (but possibly empty) cursor.
*/
DOMDatasource.prototype.GetTargets = function(sourceRes, propertyRes, truthValue) {
	if (DEBUG) debug("GetTargets() called with args: \n\t" + sourceRes.Value + 
	 "\n\t" + propertyRes.Value + "\n\t" + truthValue + "\n\n");
	var elem;	 
	if (sourceRes.Value == "urn:root")
		elem = this.dom.documentElement;
	else	
		elem = this.getElement(sourceRes.Value);
	if (!elem)
		return new XMLNullEnumerator();
	 
 	if (propertyRes.EqualsNode(NC_CHILD)) {
		var arr = [];
		var a = 0;
		var childElems = elem.getElementsByTagName("*");
		for (var i=0; i<childElems.length; i++) {
			if (childElems.item(i).hasAttribute("id"))
				arr[a++] = this.makeElementResource(childElems.item(i));
		}	
		return new XMLArrayEnumerator(arr);
 	}
	 
	 
	return new XMLNullEnumerator();
}

/**
* Query whether an assertion exists in this graph.
*/
DOMDatasource.prototype.HasAssertion = function(sourceRes, propertyRes, targetNode, truthValue) {
	if (!truthValue) {
		return false;
	}
	if (DEBUG) debug("HasAssertion() called with args: \n\t" + this.getValue(sourceRes) + 
	 "\n\t" + this.getValue(propertyRes) + "\n\t" + this.getValue(targetNode) + "\n\t" + truthValue + "\n\n");
	 
	var elem;	 
	if (sourceRes.Value == "urn:root")
		elem = this.dom.documentElement;
	else	
		elem = this.getElement(sourceRes.Value);
	if (!elem)
		return false;
	if (propertyRes.EqualsNode(RS_INSTANCEOF)) {
		if (targetNode.EqualsNode(RS_SEQ)) {
			return this.hasChildren(elem);
		}
		if (targetNode.EqualsNode(RS_BAG)) {
			return false;
		}
		if (targetNode.EqualsNode(RS_ALT)) {
			return false;
		}
	}
	if (propertyRes.EqualsNode(RS_TYPE)) {
		if (targetNode.EqualsNode(NC_BOOKMARKSEPARATOR)) {
			return false;
		}
		return true;
	}
	var attrVal = this.getAttribute(elem, propertyRes.Value);	
	if (!attrVal) 
		return false;
	if (attrVal == "*")
		return true;
	var literal = this.testLiteral(targetNode);
	if (!literal)
		return false;
	return (attrVal == literal.Value); 
	
}
/**
* Add an assertion to the graph.
*/
DOMDatasource.prototype.Assert = function(sourceRes, propertyRes, targetNode, truthValue) {
	if (DEBUG) debug("Assert() called with args: \n\t" + sourceRes.Value + 
	 "\n\t" + propertyRes.Value + "\n\t" + truthValue + "\n\n");
}
/**
* Remove an assertion from the graph.
*/
DOMDatasource.prototype.Unassert = function(sourceRes, propertyRes, targetNode) {
	if (DEBUG) debug("Unssert() called with args: \n\t" + sourceRes.Value + 
	 "\n\t" + propertyRes.Value + "\n\t" + targetNode.Value + "\n\n");
}/**
* Change an assertion from
*
*   [aSource]--[aProperty]-->[aOldTarget]
*
* to
* 
*   [aSource]--[aProperty]-->[aNewTarget]
*/
DOMDatasource.prototype.Change = function(sourceRes, propertyRes, oldTargetNode, newTargetNode) {
}
/**
* 'Move' an assertion from
*
*   [aOldSource]--[aProperty]-->[aTarget]
*
* to
* 
*   [aNewSource]--[aProperty]-->[aTarget]
*/
DOMDatasource.prototype.Move = function(oldSourceRes, newSourceRes, propertyRes, targetNode) {
}
/**
* Add an observer to this data source. If the datasource
* supports observers, the datasource source should hold a strong
* reference to the observer.
*/
DOMDatasource.prototype.AddObserver = function(rdfObserver) {
}
/**
* Remove an observer from this data source.
*/
DOMDatasource.prototype.RemoveObserver = function(rdfObserver) {
}
/**
* Get a cursor to iterate over all the arcs that point into a node.
*
* @return NS_OK unless a catastrophic error occurs. If the method
* returns NS_OK, you may assume that labels points to a valid (but
* possible empty) nsISimpleEnumerator object.
*/
DOMDatasource.prototype.ArcLabelsIn = function(rdfNode) {
	if (DEBUG) debug("ArclabelsIn() called with args: \n\t" + rdfNode.Value);
	if (rdfNode.Value == "urn:root")
		elem = this.dom.documentElement;
	else	
		elem = this.getElement(rdfNode.Value);
	if (!elem)
		return new XMLNullEnumerator();
	var parent = elem.parentNode;	
	if (!elem)
		return new XMLNullEnumerator();
	var arr = [];
	arr[0] = NC_CHILD;
	return new XMLArrayEnumerator(arr);
}
/**
* Get a cursor to iterate over all the arcs that originate in
* a resource.
*
* @return NS_OK unless a catastrophic error occurs. If the method
* returns NS_OK, you may assume that labels points to a valid (but
* possible empty) nsISimpleEnumerator object.
*/
DOMDatasource.prototype.ArcLabelsOut = function(rdfResource) {
	if (DEBUG) debug("ArclabelsOut() called with args: \n\t" + rdfResource.Value);
	return new XMLNullEnumerator();
}
/**
* Retrieve all of the resources that the data source currently
* refers to.
*/
DOMDatasource.prototype.GetAllResources = function() {
	if (DEBUG) debug("GetAllResources()");
	return new XMLNullEnumerator();
}
/**
* Returns the set of all commands defined for a given source.
*/
DOMDatasource.prototype.GetAllCommands = function(sourceRes) {
	if (DEBUG) debug("GetAllCommands() called:");
	return new XMLNullEnumerator();
}
DOMDatasource.prototype.GetAllCmds = function(sourceRes) {
	if (DEBUG) debug("GetAllCmds() called:");
	return new XMLNullEnumerator();
}
/**
* Returns whether a given command is enabled for a set of sources (nsISupportsArray). 
*/
DOMDatasource.prototype.IsCommandEnabled = function(sourcesArray, commandRes, argumentsArray) {
}
/**
* Perform the specified command on set of sources.
*/
DOMDatasource.prototype.DoCommand = function(sourcesArray, commandRes, argumentsArray) {
	if (DEBUG) debug("DoCommand() called:");
}
/**
* Returns true if the specified node is pointed to by the specified arc.
* Equivalent to enumerating ArcLabelsIn and comparing for the specified arc.
*/
DOMDatasource.prototype.hasArcIn = function(rdfNode, arcRes) {
	if (DEBUG) debug("hasArcIn() called with args:" + rdfNode.Value + " " + arcRes.Value);
}
/**
* Returns true if the specified node has the specified outward arc.
* Equivalent to enumerating ArcLabelsOut and comparing for the specified arc.
*/
DOMDatasource.prototype.hasArcOut = function(sourceRes, arcRes) {
	if (DEBUG) debug("hasArcOut() called with args:" + sourceRes.Value + " " + arcRes.Value);
}
DOMDatasource.prototype.getElement = function(rdfURI) {
	var i = rdfURI.indexOf("#");
	if (i != -1) {
		var id = rdfURI.substr(i+1);
		return this.getElementById(this.dom, id);
	}
	return null;
}
DOMDatasource.prototype.getAttribute = function(elem, rdfURI) {
	var i = rdfURI.indexOf("::");
	if (i != -1) {
		var attrName = rdfURI.substr(i+2);
		return elem.getAttribute(attrName);
	}
	return null;
}
DOMDatasource.prototype.getElementById = function(element, id) {
	var elems = element.getElementsByTagName("*");
	for (var i=0; i<elems.length; i++) {
		if (elems[i].getAttribute("id") == id)
			return elems[i];
	}
	return null;
}
/* a child element requires an id attribute to make this a Seq.
*	simple attribute-carrying child elements do not count.
*/
DOMDatasource.prototype.hasChildren = function(element) {
	var childElems = element.getElementsByTagName("*");
	for (var i=0; i<childElems.length; i++) {
		if (childElems[i].hasAttribute("id"))
			return true;
	}
	return false;
}
DOMDatasource.prototype.countChildren = function(element) {
	var childElems = element.getElementsByTagName("*");
	var count = 0;
	for (var i=0; i<childElems.length; i++) {
		if (childElems[i].hasAttribute("id"))
			count++;
	}
	return count;
}
DOMDatasource.prototype.makeElementResource = function(element) {
	return RDF.GetResource(this.URI + "#" + element.getAttribute("id"));
}
DOMDatasource.prototype.testLiteral = function(literal) {
	try {
   	return  literal.QueryInterface(Components.interfaces.nsIRDFLiteral);
   } 
   catch (e) {
   	return null;
   }	
}
DOMDatasource.prototype.testResource = function(literal) {
	try {
   	return  literal.QueryInterface(Components.interfaces.nsIRDFResource);
   } 
   catch (e) {
   	return null;
   }	
}
DOMDatasource.prototype.getValue = function(rdfNode) {
	var res = this.testResource(rdfNode);
	if (res)
		return res.Value;
	var lit = this.testLiteral(rdfNode);
	if (lit)
		return lit.Value;
	return rdfNode.Value;	
}


function XMLNullEnumerator() {
}
XMLNullEnumerator.prototype.hasMoreElements = function() {
	return false;
}
XMLNullEnumerator.prototype.getNext = function() {
	return null;
}
function XMLArrayEnumerator(itemsArray) {
	this.itemsArray = itemsArray;
	this.index = 0;
}
XMLArrayEnumerator.prototype.hasMoreElements = function() {
	if (DEBUG) debug("hasMoreElements:" + this.itemsArray.length + " " + this.index);
	return (this.index < this.itemsArray.length);
}
XMLArrayEnumerator.prototype.getNext = function() {
	if (DEBUG) debug("getNext:" + this.itemsArray.length + " " + this.index);
	if (this.index < this.itemsArray.length)
		return this.itemsArray[this.index++];
	else	
		return null;
}


