/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is XulApp IDE.
 *
 * The Initial Developer of the Original Code is Synesis Software (USA) Inc.
 *

 * Portions created by the Initial Developer are Copyright (C) 2001-2005
 * Synesis Software (USA) Inc. the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * 	Peter Wilson, orignal author.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the LGPL or the GPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 *
 * ***** END LICENSE BLOCK ***** */
netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
 
const NS_RDF_NO_VALUE           = 0xa0002;
const NS_RDF_ASSERTION_REJECTED = 0xa0003;

var RDF =  Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);

function DatasourceWrapper()
{
  this.mObservers = [];
  this.innerDS = null;
  this.URI = null;
}

DatasourceWrapper.prototype.GetSource = function(pred, obj, tv) {
	 return this.innerDS.GetSource(pred, obj, tv);
}

DatasourceWrapper.prototype.GetSources = function(pred, obj, tv) {
	 return this.innerDS.GetSources(pred, obj, tv);
}

DatasourceWrapper.prototype.GetTarget = function(subj, pred, tv) {
	 return this.innerDS.GetTarget(subj, pred, tv);
}

DatasourceWrapper.prototype.GetTargets = function(subj, pred, tv) {
	 return this.innerDS.GetTargets(subj, pred, tv);
}

DatasourceWrapper.prototype.Assert = function(subj, pred, obj, tv) {
	throw NS_RDF_ASSERTION_REJECTED; 
}

DatasourceWrapper.prototype.Unassert = function(subj, pred, obj, tv) {
	throw NS_RDF_ASSERTION_REJECTED; 
}

DatasourceWrapper.prototype.Change = function(subj, pred, oldobj, newobj) {
	throw NS_RDF_ASSERTION_REJECTED; 
}

DatasourceWrapper.prototype.Move = function(oldsubj, newsubj, pred, obj)  {
	throw NS_RDF_ASSERTION_REJECTED; 
}

DatasourceWrapper.prototype.HasAssertion = function(subj, pred, obj, tv) {
	return this.innerDS.HasAssertion(subj, pred, obj, tv);
}

DatasourceWrapper.prototype.AddObserver = function(aObserver) {
	 this.mObservers.push(aObserver);
}

DatasourceWrapper.prototype.RemoveObserver = function(aObserver) {
	for (var i = 0; i < this.mObservers.length; i++) {
		if (aObserver == this.mObservers[i]) {
			this.mObservers.splice(i, 1);
			break;
		}
	}
}

DatasourceWrapper.prototype.ArcLabelsIn = function(obj) {
	return this.innerDS.ArcLabelsIn(obj);
}

DatasourceWrapper.prototype.ArcLabelsOut = function(subj) {
	return this.innerDS.ArcLabelsOut(obj);
}

DatasourceWrapper.prototype.GetAllResources = function() {
	return this.innerDS.GetAllResources();
}

DatasourceWrapper.prototype.hasArcIn = function(obj, pred) {
	return this.innerDS.hasArcIn(obj, pred);
}

DatasourceWrapper.prototype.hasArcOut = function(subj, pred) {
	return this.innerDS.hasArcOut(subj, pred);
}

/* nsIRDFObserver */
DatasourceWrapper.prototype.onAssert = function(ds, subj, pred, obj) {
	for (var obs in this.mObservers)
		obs.onAssert(this, subj, pred, obj);
}

DatasourceWrapper.prototype.onUnassert = function(ds, subj, pred, obj) {
	for (var obs in this.mObservers)
		obs.onUnassert(this, subj, pred, obj);
}

DatasourceWrapper.prototype.onChange = function(ds, subj, pred, oldobj, newobj) {
	for (var obs in this.mObservers)
		obs.onChange(ds, subj, pred, oldobj, newobj);
}

DatasourceWrapper.prototype.onMove = function(ds, oldsubj, newsubj, pred, obj) {
	for (var obs in this.mObservers)
		obs.onMove(ds, oldsubj, newsubj, pred, obj);
}


