/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is XulApp IDE.
 *
 * The Initial Developer of the Original Code is Synesis Software (USA) Inc.
 *

 * Portions created by the Initial Developer are Copyright (C) 2001-2005
 * Synesis Software (USA) Inc. the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * 	Peter Wilson, orignal author.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the LGPL or the GPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 *
 * ***** END LICENSE BLOCK ***** */
netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
 
const knownExtensions = ["xul", "js", "xjs", "png", "xml", "css", "rdf", "rng", "xsl"];
function DirSortedDatasource() {
	this.URI = "rdf:DirSortedFiles",
	this.innerDS = RDF.GetDataSource("rdf:files");
	this.AddObserver(this);
	this.NC = "http://home.netscape.com/NC-rdf#";
	this.NC_NAME         = RDF.GetResource(this.NC + "Name");
	this.NC_ISDIRECTORY = RDF.GetResource(this.NC + "IsDirectory");
	this.NC_DIRECTORY_SORT = RDF.GetResource(this.NC + "DirectorySort");
	this.NC_EXTENSION = RDF.GetResource(this.NC + "extension");
	this.NC_EXT_ICON = RDF.GetResource(this.NC + "extIcon");
}
DirSortedDatasource.prototype = new DatasourceWrapper();
DirSortedDatasource.prototype.GetTarget = function(subj, pred, tv) {
	if (pred == this.NC_DIRECTORY_SORT) {
		var name = this.innerDS.GetTarget(subj, this.NC_NAME, true)
		  .QueryInterface(Components.interfaces.nsIRDFLiteral)
		  .Value;
		var isDirectory = this.innerDS.GetTarget(subj, this.NC_ISDIRECTORY, true)
		  .QueryInterface(Components.interfaces.nsIRDFLiteral)
		  .Value;
		return RDF.GetLiteral(((isDirectory=="true")?"0":"1")+name.toUpperCase());
	}
	if (pred == this.NC_EXT_ICON) {
		isDirectory = this.innerDS.GetTarget(subj, this.NC_ISDIRECTORY, true)
		  .QueryInterface(Components.interfaces.nsIRDFLiteral)
		  .Value;
		var ext = this.innerDS.GetTarget(subj, this.NC_EXTENSION, true)
		  .QueryInterface(Components.interfaces.nsIRDFLiteral)
		  .Value;
		return RDF.GetLiteral(this.mapExtension(ext, isDirectory));
	}
	return this.innerDS.GetTarget(subj, pred, tv);
}

DirSortedDatasource.prototype.HasAssertion = function(subj, pred, obj, tv) {
	if (pred == this.NC_DIRECTORY_SORT) {
		var isDirectory = obj.QueryInterface(Components.interfaces.nsIRDFLiteral);
		if (isDirectory)
			return this.innerDS.HasAssertion(subj, pred,
											 RDF.GetLiteral(!isDirectory.Value),
											 tv);
	}
	if (pred == this.NC_EXT_ICON) {
		return true;
	}
	
	return this.innerDS.HasAssertion(subj, pred, obj, tv);
}
DirSortedDatasource.prototype.mapExtension = function(ext, isDirectory) {
	if (isDirectory == "true")
		return "dir";
	ext = ext.substr(1);
	for (i=0; i < knownExtensions.length; i++) {
		if (knownExtensions[i] == ext)
			return ext;
	}
	return "zzzzzz";
	
}


var DS = new DirSortedDatasource();

function init() {
	var tree = document.getElementById("tree");
	tree.database.AddDataSource(DS);
	tree.setAttribute("ref", "file:///c|/");
}

function finish() {
	DS.RemoveObserver(DS);
}
