/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is XulApp IDE.
 *
 * The Initial Developer of the Original Code is Synesis Software (USA) Inc.
 *

 * Portions created by the Initial Developer are Copyright (C) 2001-2005
 * Synesis Software (USA) Inc. the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * 	Peter Wilson, orignal author.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the LGPL or the GPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 *
 * ***** END LICENSE BLOCK ***** */
 
netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	
function XSLTemplate(id, dom) {
  	this.XSLT = new XSLTProcessor();
	this.XSL_NS = "http://www.w3.org/1999/XSL/Transform";
	this.XHTML_NS = "http://www.w3.org/1999/xhtml";
	this.id = id;
	this.xmlTemplate = document.getElementById(this.id);
	
	// Build end marker. (CSS styling and some element types do not allow intervening xul elements)
	this.endMarker = document.createElement("xmltemplateendmarker");
	this.endMarker.setAttribute("hidden", true);
	this.xmlTemplate.parentNode.insertBefore(this.endMarker, this.xmlTemplate.nextSibling);
	
	// make a copy of the template as a full document.
	this.xslDom = document.implementation.createDocument(this.XHTML_NS,"", null);
	var templateCopy = this.xmlTemplate.cloneNode(true);
	var node = this.xmlTemplate.firstChild;
	while (node) {
		this.xslDom.appendChild(node);
		node = node.nextSibling;
	}
						
	// load xml document.
	if (dom)
		this.dom = dom;
	else	{
		this.uri	= this.xmlTemplate.getAttribute("uri")
		if (this.uri) {
			this.dom = Utility.loadDOMFromURI("text/xml", this.uri);
			assert(this.dom, "Loading XML for " + this.uri + " failed.");
		}	
	}
	this.XSLT.importStylesheet(this.xslDom);
}

XSLTemplate.prototype.build = function() {
	// Clear existing generated content (this is tagged by xmltemplateendmarker element).
	var templateNode = this.xmlTemplate;
	while (templateNode.nextSibling != this.endMarker)
			templateNode.parentNode.removeChild(templateNode.nextSibling);
	
	// Do the deed.
	var newDom = this.XSLT.transformToDocument(this.dom);
	
	// Copy the results back into the xul document.
	// This assumes that they will be rooted in a single documentElement.
	var parentNode = this.xmlTemplate.parentNode;
	var node = newDom.documentElement.firstChild;
	while (node) {
		var theNextNode = node.nextSibling;
		parentNode.insertBefore(node, this.endMarker);
		node = theNextNode;
	}
}

XSLTemplate.prototype.setStringParam = function(paramId, value) {
	var params = this.xslDom.getElementsByTagName("param");
	// only xsl:param with the correct id will be changed. 
	// This allows other instances of the same param in nested templates
	for (var i=0; i< params.length; i++) {
		var param = params.item(i);
		if (param.getAttribute("id") == paramId) {
			param.setAttribute("select", "'" + value + "'"); // Note use of extra apostrophies.
			return;
		}
	}
}
