<?xml version="1.0"?>
<xsl:stylesheet version="1.0" 
		xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
		xmlns:xul="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul"
		xmlns:html="http://www.w3.org/1999/xhtml"
		xmlns:xjs="http://xulapp.org/xjs">
	

	<xsl:output method="xml" doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" 
				 doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"
				 media-type="application/xhtml+xml"/>	
	
	<xsl:template match="/">
		<xsl:processing-instruction name="xml-stylesheet">
			<xsl:text>href="xulapp-org-xjs.css" type="text/css"</xsl:text>
		</xsl:processing-instruction>
		
		<html:html>
			<html:head>
				<html:title>Program Types</html:title>
			</html:head>
			<html:body>
				<xsl:apply-templates/>
			</html:body>
		</html:html>	
	</xsl:template>
	
	<xsl:template match="xjs:class">
		<xul:xa-class>
			<xul:xa-class-stag><xsl:text>class </xsl:text></xul:xa-class-stag>
			<xsl:apply-templates select="./name"/>
			<xul:xa-subblock>
				<xsl:apply-templates select="./*[not(self::name)]"/>
			</xul:xa-subblock>					
		</xul:xa-class>	
	</xsl:template>
	
	<xsl:template match="xjs:documentation">
		<xul:xa-documentation>
			<xul:xa-documentation-stag><xsl:text>documentation</xsl:text></xul:xa-documentation-stag>
			<html:div>
				<xsl:apply-templates/>
			</html:div>					
		</xul:xa-documentation>	
	</xsl:template>
	
	<xsl:template match="xjs:static">
		<xul:xa-static>
			<xul:xa-static-stag><xsl:text>static</xsl:text></xul:xa-static-stag>
				<xul:xa-subblock>
					<xsl:apply-templates/>
				</xul:xa-subblock>					
		</xul:xa-static>	
	</xsl:template>

	<xsl:template match="xjs:instance">
		<xul:xa-instance>
			<xul:xa-instance-stag><xsl:text>instance</xsl:text></xul:xa-instance-stag>
			<xul:xa-subblock>
				<xsl:apply-templates/>
			</xul:xa-subblock>					
		</xul:xa-instance>	
	</xsl:template>
	
	<xsl:template match="xjs:name">
		<xul:xa-name><xsl:value-of select="."/></xul:xa-name>
	</xsl:template>
	
	<xsl:template match="xjs:function">
		<xul:xa-function>
			<xul:xa-function-stag><xsl:text>function </xsl:text></xul:xa-function-stag>
			<xsl:apply-templates select="./name"/>
			<xsl:apply-templates select="./*[not(self::name)]"/>
		</xul:xa-function>	
	</xsl:template>
	
	<xsl:template match="xjs:if">
			<xul:xa-if>
				<xul:xa-if-stag><xsl:text>if </xsl:text></xul:xa-if-stag>
					<xsl:apply-templates/>
			</xul:xa-if>	
	</xsl:template>
	
	<xsl:template match="xjs:cond">
			<xul:xa-cond>
				<xul:xa-cond-stag><xsl:text>( </xsl:text></xul:xa-cond-stag>
				<xul:xa-cond-text>
					<xsl:apply-templates/>
				</xul:xa-cond-text>					
				<xul:xa-cond-etag><xsl:text> )</xsl:text></xul:xa-cond-etag>
			</xul:xa-cond>	
	</xsl:template>

	<xsl:template match="xjs:block">
			<xul:xa-block>
				<xul:xa-block-stag><xsl:text>{</xsl:text></xul:xa-block-stag>
				<xul:xa-subblock>
					<xsl:apply-templates/>
				</xul:xa-subblock>
				<xul:xa-block-etag><xsl:text>}</xsl:text></xul:xa-block-etag>
			</xul:xa-block>	
	</xsl:template>

	<xsl:template match="xjs:else">
			<xul:xa-else>
				<xul:xa-else-stag><xsl:text>else </xsl:text></xul:xa-else-stag>
				<xsl:apply-templates/>
			</xul:xa-else>					
	</xsl:template>

	
	<xsl:template match="xjs:parameters">
			<xul:xa-parameters>
				<xul:xa-parameters-stag><xsl:text> ( </xsl:text></xul:xa-parameters-stag>
				<xsl:apply-templates/>
				<xul:xa-parameters-etag><xsl:text> )</xsl:text></xul:xa-parameters-etag>
			</xul:xa-parameters>	
	</xsl:template>
	
	<xsl:template match="xjs:parameter">
			<xul:xa-parameter>
				<xsl:apply-templates/>
			</xul:xa-parameter>	
	</xsl:template>
	

	<xsl:template match="xjs:comment">
			<xul:xa-comment>
				<xul:xa-comment-stag><xsl:text>/* </xsl:text></xul:xa-comment-stag>
				<html:span>
					<xsl:apply-templates/>
				</html:span>					
				<xul:xa-comment-etag><xsl:text> */</xsl:text></xul:xa-comment-etag>
			</xul:xa-comment>	
	</xsl:template>

	<xsl:template match="xjs:stmt">
			<xul:xa-stmt>
				<xsl:apply-templates/>
			</xul:xa-stmt>	
	</xsl:template>
	
	<xsl:template match="xjs:string">
		<xul:xa-string>
				<xul:xa-string-stag>
					<xsl:text>"</xsl:text>
				</xul:xa-string-stag>					
				<xsl:apply-templates/>
				<xul:xa-string-etag>
					<xsl:text>"</xsl:text>
				</xul:xa-string-etag>					
		</xul:xa-string>
	</xsl:template>
	
	<xsl:template match="xjs:string[@apos]">
		<xul:xa-string>
				<xsl:attribute name="apos">
					<xsl:text>true</xsl:text>
				</xsl:attribute>

				<xul:xa-string-stag>
					<xsl:text>'</xsl:text>
				</xul:xa-string-stag>					
				<xsl:apply-templates/>
				<xul:xa-string-etag>
					<xsl:text>'</xsl:text>
				</xul:xa-string-etag>					
		</xul:xa-string>
	</xsl:template>

</xsl:stylesheet>
