<?xml version="1.0"?>
<stylesheet version="1.0" 
		xmlns="http://www.w3.org/1999/XSL/Transform"
		xmlns:xul="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul"
		xmlns:html="http://www.w3.org/1999/xhtml"
		xmlns:xjs="http://xulapp.org/xjs">
	

	<output method="xml" doctype-public="-//W3C//DTD XHTML 1.1//EN" 
				 doctype-system="http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd"
				 media-type="application/xhtml+xml"/>	
	
	<template match="/">
		<processing-instruction name="xml-stylesheet">
			<text>type="text/css" href="demo.css"</text>
		</processing-instruction>
		
		<html:html>
			<attribute name="onload">OnLoad(event)</attribute>
			<attribute name="onkeypress">OnKeyPress(event)</attribute>
			<attribute name="onclick">OnClick(event)</attribute>
			<html:head>
				<html:title>Program Types</html:title>
				<html:script>
					<attribute name="type">application/x-javascript</attribute>
					<attribute name="src">demo.js</attribute>
				</html:script>
			</html:head>
			<html:body>
				<apply-templates/>
			</html:body>
		</html:html>	
	</template>
	
	<template match="xjs:class">
		<xul:xa-class>
			<xul:xa-class-stag><text>class </text></xul:xa-class-stag>
			<apply-templates select="./xjs:name"/>
			<xul:xa-subblock>
				<apply-templates select="./*[not(self::xjs:name)]"/>
			</xul:xa-subblock>					
		</xul:xa-class>	
	</template>
	
	<template match="xjs:documentation">
		<xul:xa-documentation>
			<xul:xa-documentation-stag><text>documentation</text></xul:xa-documentation-stag>
			<html:div>
				<copy-of select="."/>
			</html:div>					
		</xul:xa-documentation>	
	</template>
	
	
	<template match="xjs:static">
		<xul:xa-static>
			<xul:xa-static-stag><text>static</text></xul:xa-static-stag>
				<xul:xa-subblock>
					<apply-templates/>
				</xul:xa-subblock>					
		</xul:xa-static>	
	</template>

	<template match="xjs:instance">
		<xul:xa-instance>
			<xul:xa-instance-stag><text>instance</text></xul:xa-instance-stag>
			<xul:xa-subblock>
				<apply-templates/>
			</xul:xa-subblock>					
		</xul:xa-instance>	
	</template>
	
	<template match="xjs:name">
		<xul:xa-name><value-of select="."/></xul:xa-name>
	</template>
	
	<template match="xjs:function">
		<xul:xa-function>
			<xul:xa-function-stag><text>function </text></xul:xa-function-stag>
			<apply-templates select="./name"/>
			<apply-templates select="./*[not(self::name)]"/>
		</xul:xa-function>	
	</template>
	
	<template match="xjs:if">
			<xul:xa-if>
				<xul:xa-if-stag><text>if </text></xul:xa-if-stag>
					<apply-templates/>
			</xul:xa-if>	
	</template>
	
	<template match="xjs:cond">
			<xul:xa-cond>
				<xul:xa-cond-stag><text>( </text></xul:xa-cond-stag>
				<xul:xa-cond-text>
					<apply-templates/>
				</xul:xa-cond-text>					
				<xul:xa-cond-etag><text> )</text></xul:xa-cond-etag>
			</xul:xa-cond>	
	</template>

	<template match="xjs:block">
			<xul:xa-block>
				<xul:xa-block-stag><text>{</text></xul:xa-block-stag>
				<xul:xa-subblock>
					<apply-templates/>
				</xul:xa-subblock>
				<xul:xa-block-etag><text>}</text></xul:xa-block-etag>
			</xul:xa-block>	
	</template>

	<template match="xjs:else">
			<xul:xa-else>
				<xul:xa-else-stag><text>else </text></xul:xa-else-stag>
				<apply-templates/>
			</xul:xa-else>					
	</template>

	
	<template match="xjs:parameters">
			<xul:xa-parameters>
				<xul:xa-parameters-stag><text> ( </text></xul:xa-parameters-stag>
				<apply-templates/>
				<xul:xa-parameters-etag><text> )</text></xul:xa-parameters-etag>
			</xul:xa-parameters>	
	</template>
	
	<template match="xjs:parameter">
			<xul:xa-parameter>
				<apply-templates/>
			</xul:xa-parameter>	
	</template>
	

	<template match="xjs:comment">
			<xul:xa-comment>
				<xul:xa-comment-stag><text>/* </text></xul:xa-comment-stag>
				<html:span>
					<copy-of select="."/>
				</html:span>					
				<xul:xa-comment-etag><text> */</text></xul:xa-comment-etag>
			</xul:xa-comment>	
	</template>

	<template match="xjs:stmt">
			<xul:xa-stmt>
				<apply-templates/>
			</xul:xa-stmt>	
	</template>
	
	<template match="xjs:string">
		<xul:xa-string>
				<xul:xa-string-stag>
					<text>"</text>
				</xul:xa-string-stag>					
				<apply-templates/>
				<xul:xa-string-etag>
					<text>"</text>
				</xul:xa-string-etag>					
		</xul:xa-string>
	</template>
	
	<template match="xjs:string[@apos]">
		<xul:xa-string>
				<attribute name="apos">
					<text>true</text>
				</attribute>

				<xul:xa-string-stag>
					<text>'</text>
				</xul:xa-string-stag>					
				<apply-templates/>
				<xul:xa-string-etag>
					<text>'</text>
				</xul:xa-string-etag>					
		</xul:xa-string>
	</template>

</stylesheet>
