/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is XulApp IDE.
 *
 * The Initial Developer of the Original Code is Synesis Software (USA) Inc.
 *

 * Portions created by the Initial Developer are Copyright (C) 2001-2005
 * Synesis Software (USA) Inc. the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * 	Peter Wilson, orignal author.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the LGPL or the GPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 *
 * ***** END LICENSE BLOCK ***** */
 
netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
var xulapp = window.arguments[0];
var openTool = window.arguments[1];

var modelDoc;
var xmlBrowser;
var viewDoc;
var xslInputDoc;
var winCount = 0;

var codeTemplates = null;

var transactionManager = new TransactionManager();

var prevAnchor = {anchorNode:null, anchorOffset:-1, oldValue:null};

const xablock = "xa-block";
const xasubblock = "xa-subblock";

const TWIPS = 12;

const collapsibleElements = ["xa-class-stag", "xa-documentation-stag", "xa-static-stag", "xa-instance-stag", "xa-function-stag", "xa-comment-stag"];
const allowsEnterKey = ["span"];

const XJS_BASE = "chrome://xulapp/content/tools/xjsEditor/";

const ViewToXjs ="xulapp-org-xjs-inverse.xsl"

var setFocusRange;

function OnLoad() {
	xmlBrowser = document.getElementById("xmlBrowser");
	viewDoc = xmlBrowser.contentDocument;
	modelDoc = Utility.loadDOMFromURI("text/xml", openTool.fileURI);
	
	xslInputDoc = Utility.loadDOMFromURI("text/xml", XJS_BASE + "xulapp-org-xjs.xsl");

	
	codeTemplates = loadAndTransform(XJS_BASE + "codeTemplates.xjs",
									 XJS_BASE + "codeTemplates.xsl",
									 null);
    codeTemplates.getElementById = getElementById;	
    
	transactionManager.maxTransactionCount = -1; // No limit
	
	//Note: We can't use the transform directly in the xjs file 
	// as transforms for mixed URL domains are not permitted. 
	// (file:/chrome: in our case).
	// This is an ill wind:
	// 1. The loaded browser document lacked scrolbars - for no apparent reason.
	// 2. The transform is not hard-coded in the xjs source.
	// 3. When linking to other xjs documents we need to save/restore the current document anyway.
	
	// Convert Xjs source file to an xhtml document.
	var params = [];
	var baseURI = File.dirPath(openTool.fileURI);
	params[0] = {name:"baseURI", value:baseURI};
	var tempViewDoc = transform(modelDoc, xslInputDoc, params);
							  
	// Replace the dummy default-xjs.xhtml with the new document.	
	/*
	var srcBodyElem = tempViewDoc.getElementsByTagName("body")[0];							  
	var srcBodyImported = viewDoc.importNode(srcBodyElem, true);
	
	var htmlElem = viewDoc.documentElement;
	var bodyElem = htmlElem.getElementsByTagName("body")[0];							  
	htmlElem.replaceChild(srcBodyImported, bodyElem);
	*/
	var tempViewHtml = viewDoc.importNode(tempViewDoc.documentElement, true);
	viewDoc.replaceChild(tempViewHtml, viewDoc.documentElement);
	setTitle();
	setFocusRange = viewDoc.createRange();
}

function OnClick(event) {
	var elem = event.target;
	if (event.detail == 1 && shouldSelectParent(elem)) {
		var selection = xmlBrowser.contentWindow.getSelection();
		selection.selectAllChildren(elem.parentNode);
		event.preventBubble();
		return;
	}
	else if (event.detail == 2) { // Double click.
		var parentElem = elem.parentNode;
		if (isCollapsibleElement(elem)) {
			if (parentElem.getAttribute("xa-collapsed")=="true") 
				parentElem.removeAttribute("xa-collapsed");
			else 
				parentElem.setAttribute("xa-collapsed","true");
		}
	}
}

function shouldSelectParent(elem) {
	return (elem.localName.search(/(-stag$)|(-etag$)/) != -1);
}

function isCollapsibleElement(elem) {

	if (!elem)
		return false;
	for (var i=0; i<collapsibleElements.length; i++) {
		if (elem.localName == collapsibleElements[i])
			return true;
	}
	return false;
}

function T1Click(event) {
}

function setTitle() {
	var ind = (openTool.isModified)? " + ":" - ";
	var title = "XJS Editor" + ind + File.URLToPath(openTool.fileURI);
	document.documentElement.setAttribute("title",title)
}

function OnKeyPress(event) {
	var tran;
	if (event.ctrlKey || event.altKey || event.metaKey ) {
		return;
	}	
	switch (event.keyCode) {
	case VK_RIGHT:
	case VK_LEFT:
	case VK_UP:
	case VK_DOWN:
	case VK_HOME:
	case VK_END:
	case VK_PAGE_DOWN:
	case VK_PAGE_UP:
	case VK_TAB: //TODO add other control keys which should be ignored.
		return;
	}

	var node = event.target;
	if (node.nodeType != NODE_TYPE_ELEMENT) 
		return;
	if (!isInputElement(node)) 
		return;
	var selection = xmlBrowser.contentWindow.getSelection();

	if (selection.anchorNode == selection.focusNode) {
		// Cache old values for current node.
		var elem = selection.anchorNode.parentNode;
		if (!prevAnchor.anchorNode || !prevAnchor.anchorNode.isSameNode(elem)) {
			prevAnchor.anchorNode = elem;
			prevAnchor.anchorOffset = selection.anchorOffset;
			prevAnchor.oldValue = elem.firstChild.nodeValue;
			debug("Elem nv" + elem.localName);
		}
		var textNode = node.firstChild;
		var from = selection.anchorOffset;
		var to	= selection.focusOffset;
		if (from > to) {
			from = to;
			to	= selection.anchorOffset;
		}
		//debug("From:" + from + " to:" + to);
		switch (event.keyCode) {
		case VK_BACK_SPACE:
			if (from == to) {
				from--;
				if (from < 0)
					return;
			}	
			textNode.nodeValue = textNode.nodeValue.substr(0,from)
										+ textNode.nodeValue.substr(to);
			selection.collapse(textNode, from);
			break;
		case VK_DELETE:
			if (from == to) {
				if (to > textNode.nodeValue.length)
					return;
				to++;
			}	
			textNode.nodeValue = textNode.nodeValue.substr(0,from)
										+ textNode.nodeValue.substr(to);
			selection.collapse(textNode, from);
			break;
		case VK_ENTER:
		case VK_RETURN:
			if (!elemAllowsEnterKey(event))
				break;
			textNode.nodeValue = textNode.nodeValue.substr(0,from)
										+ "\n" 
										+ textNode.nodeValue.substr(to);
			selection.collapse(textNode, from+1);											
			break;
		default:
			if (event.charCode == 0) // non-typeable character NumKey etc.
				return;
			var chars = mapEntities(event);
			textNode.nodeValue = textNode.nodeValue.substr(0,from)
										+ chars 
										+ textNode.nodeValue.substr(to);
			selection.collapse(textNode, from + chars.length);											
		}
		tran = new ValueTransaction(textNode, prevAnchor)
		transactionManager.doTransaction(tran);
		OnTransaction(transactionManager);
	}
}
function OnKeyEnter(event) {

}
function elemAllowsEnterKey(event) {
	var elemName = event.target.localName;
	for (var i=0; i< allowsEnterKey.length; i++) {
		if (allowsEnterKey[i] == elemName) {
			debug("elemAllowsEnterKey" + elemName);
			return true;
		}
	}
	return false;
}

function cmdInsertCode(codeTemplateName) {
	var selection = xmlBrowser.contentWindow.getSelection();
	var tgtElem = selection.anchorNode;
	if (!tgtElem)
		return;
	processTemplateKey(tgtElem, codeTemplateName);
}


// Process requests to insert templates in document at current point.
function processTemplateKey(tgtElem, codeTemplateName) {
	//TODO is it legal here?
	//TODO templates should be context sensative 
	//	i.e. Alt i in html gives italic, Alt i in code gves if.
	var codeTemplateName;
	if (!codeTemplateName)
		return;
	var codeTemplate = codeTemplates.getElementById(codeTemplateName);
	if (!codeTemplate)
		return;
	var codeElem = codeTemplate.getElementsByTagName("code")[0];
	if (!codeElem) {
		debug ("codeTemplate:" + codeTemplateName + " is missing code element.");
		return;
	}
	codeElem = codeElem.cloneNode(true);
	var block = null;
	var elem = tgtElem;
	while (elem) {
		if (elem.localName == xasubblock || elem.localName == xablock) {
			block = elem;
			break;
		}
		elem = elem.parentNode;
	}
	if (!block)
		return;
	if (codeTemplateName == "else")	{
		//TODO check no else already in place.
		block.appendChild(codeElem);
	}
	else {
		
	}
}

function mapEntities(event) {
	switch (event.charCode) {
	case VK_LT:
		return "&lt;";
	case VK_GT:
		return "&gt;";
	case VK_QUOTE:
		return "&quot;";
	case VK_AMP:
		if (!event.altKey)
			return "&amp;";
	}
	return String.fromCharCode(event.charCode);
}

function isInputElement(elem) {
	var enabled = viewDoc.defaultView.getComputedStyle(elem, '' ).getPropertyValue("-moz-user-input");	 
	if (enabled != "enabled")
		return false;
	var modify = viewDoc.defaultView.getComputedStyle(elem, '' ).getPropertyValue("-moz-user-modify");	
	return (modify != "read-only");
}


function OnKeyDown(event) {
	var xLeft;
	var yTop;
	switch (event.keyCode) {
	case VK_UP:
	case VK_DOWN:
	case VK_PAGE_DOWN:
	case VK_PAGE_UP:
		return;
	case VK_HOME:
		if (!event.ctrlKey) {
			var selection = xmlBrowser.contentWindow.getSelection();
			selection.collapse(event.target, 0);
			//How do we stop this monster??
  			event.preventDefault();
  			event.preventBubble();
  			event.preventCapture();
  			event.stopPropagation();
			return;	
		}
		return;
	case VK_END:
		if (!event.ctrlKey) {
			return;
		}
	}
}
function getX() {
  //scrollBoxObject.getPosition(X, Y);
  return Math.floor(X.value/TWIPS);
}
function getY() {
  //scrollBoxObject.getPosition(X, Y);
  return Math.floor(Y.value/TWIPS);
}
function scrollTo(x, y) {
	var xMax = Math.max(desc.boxObject.width - scrollBox.boxObject.width,0);
	var yMax = Math.max(desc.boxObject.height - scrollBox.boxObject.height,0);
	x = Math.max(x, 0);
	x = Math.min(xMax, x);
	y = Math.max(y, 0);
	y = Math.min(yMax, y);
	x *= TWIPS; // The twerps use twips!
	y *= TWIPS; 
	//debug("scrollTo: descH:" + desc.boxObject.height + " sbH:" + scrollBox.boxObject.height + " x:" + x + " y:" + y);
	scrollBoxObject.scrollTo(x, y);
}

function cmdSave() {
	OnSave();
}

function cmdSaveAs() {
	OnSaveAs();
}

function cmdClose() {
	if (OnClose())
		close();
}

function cmdUndo() {
	transactionManager.undoTransaction();
	OnTransaction(transactionManager);
}

function cmdRedo() {
	transactionManager.redoTransaction();
	OnTransaction(transactionManager);
}

function cmdInsertComment(insertInto) {
}

function cmdInsertPI() {
}

function cmdInsertElement(insertInto) {
}

function cmdInsertAttribute() {
}

function cmdInsertText(insertInto) {
}

function cmdInsertCDATA(insertInto) {
}

function cmdValidate() {
	setViewDerivs(); //FIXME this does not get loaded in OnLoad.
	var viewDocElement = viewDoc.getElementById("DOCELEM");
	var namespaceURI = getElNamespaceURI(viewDocElement);
	var schema;
	if (!namespaceURI) {
		var ats = viewDoc.getElementById("DOCTYPEA");
		var publicId = null;
		if (ats) {
			var at = getAtFromAts(ats, "PUBLIC");
			if (at)
				publicId = getAvFromAt(at).firstChild.nodeValue;
		}
		if (!publicId) {
			alert("No schema could be found for this document type.");
			return;
		}
		schema = xulapp.schemas.getSchemaByPublicId(publicId);
	}
	else
		schema = xulapp.schemas.getSchemaByNamespaceURI(namespaceURI);
		
	var errorList = new ErrorList();
	if (validateViewDocument(schema, viewDocElement, errorList)) 
		text = "Valid document.";
	else
		text = "Errors found:\n";
	for (var i=0; i<errorList.errors.length; i++) {
		text+= errorList.errors[i].msg + "\n";
	}
	alert(text);
	
}

function OnTransaction(transactionManager) {
	// Enable/Disable Undo/Redo commands
	var canUndo = (transactionManager.numberOfUndoItems > 0);
	var canRedo = (transactionManager.numberOfRedoItems > 0);

	var cmdSave = document.getElementById("cmdSave");
	cmdSave.setAttribute("disabled", !canUndo);
	var cmdUndo = document.getElementById("cmdUndo");
	cmdUndo.setAttribute("disabled", !canUndo);
	var cmdRedo = document.getElementById("cmdRedo");
	cmdRedo.setAttribute("disabled", !canRedo);
	openTool.isModified = canUndo;
	setTitle();
}

function ValueTransaction(textNode, prevAnchor) {
	this.wrappedJSObject = this;
	this.elem = textNode.parentNode;
	this.newValue = this.elem.nodeValue;
	this.oldValue = prevAnchor.oldValue; // use null if added for first time.
	this.anchorOffset = prevAnchor.anchorOffset;
	this.isTransient = false;
}

ValueTransaction.prototype.doTransaction = function() {
	//nothing to do
}
ValueTransaction.prototype.undoTransaction = function() {
	//this.elem.normalize();
	var textNode = this.elem.firstChild;
	textNode.nodeValue = this.oldValue;
	debug("undoVT:" + textNode.nodeValue);
	debug("undoVT:" + textNode.parentNode.localName);
	debug("undoVT Offset:" + this.anchorOffset);
	if (this.elem.focus)
		this.elem.focus();
}
ValueTransaction.prototype.redoTransaction = function() {
	this.elem.normalize();
	var textNode = this.elem.firstChild;
	textNode.nodeValue = this.newValue;
	if (this.elem.focus)
		this.elem.focus();
}
ValueTransaction.prototype.merge = function(aTransaction) {
	aTransaction = aTransaction.aTransaction;
	if (aTransaction instanceof ValueTransaction) {
		if (this.elem.isSameNode(aTransaction.elem)) {
			this.newValue = aTransaction.newValue;
			debug("Merged:" + aTransaction.elem.localName);
			return true;
		}
	}
	return false; //Merge not supported.
}
function OnSave () {
	if (openTool) {
		openTool.save();
		setTitle();
	}	
}

function OnSaveAs () {
	if (openTool) {
		openTool.saveAs();
		setTitle();
	}	
}

function serialize() {
	var xjsDoc = XjsFromView();
	// Transformix does not put the namespace declaration on the documentElement
	xjsDoc.documentElement.setAttribute("xmlns:xjs","http://xulapp.org/xjs");
	var ser = new XULDOMSerializer(xulapp.project.xuloutput);
	ser.serialize(xjsDoc);
	return ser.XML;
	//return editor.value;
}
function XjsFromView() {
   	var xsltProc = new XSLTProcessor();

   	var xslDoc = Utility.loadDOMFromURI("text/xml", XJS_BASE + ViewToXjs);
   	xsltProc.importStylesheet(xslDoc);
   	
	var xmlDoc = xmlBrowser.contentDocument;
		
   	return xsltProc.transformToDocument(xmlDoc);

}


function OnClose() {
	if (!openTool.mightSave()) 
		return false;
	return true;	
}

function OnUnload() {
	openTool.close();
}

function loadAndTransform(xmlUri, xslUri, params)
{
	var xmlDoc = Utility.loadDOMFromURI("text/xml", xmlUri);
   	var xslDoc = Utility.loadDOMFromURI("text/xml", xslUri);
	
   	return transform(xmlDoc, xslDoc, params);
}

function transform (xmlDoc, xslDoc, params) {
   	var xsltProc = new XSLTProcessor();
   	if (params) {
   		for (var i=0; i<params.length; i++) {
			xsltProc.setParameter("", params[i].name, params[i].value);
		}	
	}	
   	
   	xsltProc.importStylesheet(xslDoc);

   	return xsltProc.transformToDocument(xmlDoc);
}

