<?xml version="1.0"?>
<xsl:stylesheet version="1.0" 
		xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
		xmlns:xul="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul"
		xmlns:html="http://www.w3.org/1999/xhtml"
		xmlns:xjs="http://xulapp.org/xjs">
	

	<xsl:output method="xml" indent="yes"/>	
	
	<xsl:template match="//html:body">
			<xjs:xjs>
				<xsl:apply-templates/>
			</xjs:xjs>
	</xsl:template>

	<xsl:template match="xul:xa-class">
		<xjs:class>
			<xsl:apply-templates/>
		</xjs:class>	
	</xsl:template>
	<xsl:template match="xul:xa-class-stag"/>

	<xsl:template match="xul:xa-documentation">
		<xjs:documentation>
			<xsl:apply-templates/>
		</xjs:documentation>	
	</xsl:template>
	<xsl:template match="xulxa-documentation-stag"/>
	
	<xsl:template match="xul:xa-static">
		<xjs:static>
			<xsl:apply-templates/>
		</xjs:static>	
	</xsl:template>
	<xsl:template match="xul:xa-static-stag"/>

	<xsl:template match="xul:xa-instance">
		<xjs:instance>
			<xsl:apply-templates/>
		</xjs:instance>	
	</xsl:template>
	<xsl:template match="xul:xa-instance-stag"/>
	
	<xsl:template match="xul:xa-name">
		<xjs:name><xsl:value-of select="."/></xjs:name>
	</xsl:template>
	
	<xsl:template match="xul:xa-function">
		<xjs:function>
			<xsl:apply-templates/>
		</xjs:function>	
	</xsl:template>
	<xsl:template match="xul:xa-function-stag"/>
	
	<xsl:template match="xul:xa-if">
		<xjs:if>
			<xsl:apply-templates/>
		</xjs:if>	
	</xsl:template>
	<xsl:template match="xul:xa-if-stag"/>
	
	<xsl:template match="xul:xa-cond">
			<xjs:cond>
				<xsl:apply-templates/>
			</xjs:cond>	
	</xsl:template>
	<xsl:template match="xul:xa-cond-stag"/>
	<xsl:template match="xa-cond-etag"/>

	<xsl:template match="xul:xa-block">
			<xjs:block>
				<xsl:apply-templates/>
			</xjs:block>	
	</xsl:template>
	<xsl:template match="xul:xa-block-stag"/>
	<xsl:template match="xul:xa-block-etag"/>


	<xsl:template match="xul:xa-else">
		<xjs:else>
			<xsl:apply-templates/>
		</xjs:else>					
	</xsl:template>
	<xsl:template match="xul:xa-else-stag"/>


	<xsl:template match="xul:xa-parameters">
		<xjs:parameters>
			<xsl:apply-templates/>
		</xjs:parameters>	
	</xsl:template>
	<xsl:template match="xul:xa-parameters-stag"/>
	<xsl:template match="xul:xa-parameters-etag"/>

	
	<xsl:template match="xul:xa-parameter">
		<xjs:parameter>
			<xsl:apply-templates/>
		</xjs:parameter>	
	</xsl:template>
	

	<xsl:template match="xul:xa-comment">
		<xjs:comment>
			<xsl:apply-templates/>
		</xjs:comment>	
	</xsl:template>
	<xsl:template match="xul:xa-comment-stag"/>
	<xsl:template match="xul:xa-comment-etag"/>


	<xsl:template match="xul:xa-stmt">
		<xjs:stmt>
			<xsl:apply-templates/>
		</xjs:stmt>	
	</xsl:template>

	<xsl:template match="xul:xa-string">
		<xjs:string>
			<xsl:apply-templates/>
		</xjs:string>
	</xsl:template>
	<xsl:template match="xul:xa-string-stag"/>
	<xsl:template match="xul:xa-string-etag"/>

		
	<xsl:template match="xul:xa-string[@apos]">
		<xjs:string>
			<xsl:attribute name="apos">
				<xsl:text>true</xsl:text>
			</xsl:attribute>
			<xsl:apply-templates/>
		</xjs:string>
	</xsl:template>

</xsl:stylesheet>
