/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is XulApp IDE.
 *
 * The Initial Developer of the Original Code is Synesis Software (USA) Inc.
 *

 * Portions created by the Initial Developer are Copyright (C) 2001-2005
 * Synesis Software (USA) Inc. the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * 	Peter Wilson, orignal author.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the LGPL or the GPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 *
 * ***** END LICENSE BLOCK ***** */
 
netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
const MIMETYPE_NEW_ITEM = "text/x-xulapp-newitem";

var toolboxObserver = { 
	onDragStart: function (event, transferData, action){
		var toolId=event.target.getAttribute("toolid");
		var nodeType=event.target.getAttribute("nodetype");
		// D&D transfer of non-text objects does not work 2002040309.
		xulapp.dropData = {dragSourceWindow: window, dragToolId: toolId, dragNodeType: nodeType};
		transferData.data=new TransferData();
		transferData.data.addDataForFlavour(MIMETYPE_NEW_ITEM, "none");
	}
};

function toolboxExpand(event) {
	var vbox = event.target.parentNode.nextSibling;
	var hidden = vbox.getAttribute("hidden");	
	if (hidden=="false") {
		vbox.setAttribute("hidden", "true");
		event.target.removeAttribute("open");
	}	
	else {	
		vbox.setAttribute("hidden", "false");
		event.target.setAttribute("open", "true");
	}	
}
var selected = null;
function toolboxMouseover(event) {
	if (selected) 
		selected.removeAttribute("selected");
	selected = event.currentTarget;
	selected.setAttribute("selected", "true");
}
function toolboxMouseout(event) {
	selected = event.currentTarget;
	selected.removeAttribute("selected");
}
