/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is XulApp IDE.
 *
 * The Initial Developer of the Original Code is Synesis Software (USA) Inc.
 *

 * Portions created by the Initial Developer are Copyright (C) 2001-2005
 * Synesis Software (USA) Inc. the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * 	Peter Wilson, orignal author.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the LGPL or the GPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 *
 * ***** END LICENSE BLOCK ***** */
 
netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");

const XHTML = "http://www.w3.org/1999/xhtml";
const TWIPS = 12;
const NODE_TYPE_ELEMENT = 1;
const	TWISTY_OPEN = "chrome://global/skin/tree/twisty-open.gif";
const	TWISTY_CLOSED = "chrome://global/skin/tree/twisty-clsd.gif";


var desc;
var RE_Whitespace = /^\s*$/;
var idNo = 0;
//map of node ids to dom nodes.
var X = {};
var Y = {};

const ACTION_BEFORE = 1;
const ACTION_ON = 2;
const ACTION_REMOVE = 3;

const MIMETYPE_NEW_ITEM = "text/x-xulapp-newitem";
const MIMETYPE_OLD_ITEM = "text/x-xulapp-olditem"; 
const MIMETYPE_TEXT = "text/unicode"; 
const ITEMTYPE_PI = "pi";
const ITEMTYPE_DOCTYPE = "doctype";
const ITEMTYPE_ELEMENT = "element";
const ITEMTYPE_ATTRIBUTE = "attribute";
const ITEMTYPE_COMMENT = "comment";
const ITEMTYPE_PCDATA = "pcdata";
const ITEMTYPE_CDATA = "cdata";
const ITEMTYPE_PLAINTEXT = "plaintext";

const DFT_PI_NAME = "xml-xxx"
const DFT_ELEM_NAME = "xxx"
const DFT_ATTR_NAME = "xxx"
const DFT_ATTR_VALUE = ""
const DFT_PCDATA_VALUE = "xxx"
const DFT_CDATA_VALUE = "xxx"
const DFT_COMMENT_VALUE = "xxx"

const DRAGDROP_ACTION_NONE = 0;
const DRAGDROP_ACTION_COPY = 1;
const DRAGDROP_ACTION_MOVE = 2;
const DRAGDROP_ACTION_LINK = 4;
const VK_CANCEL         = 0x03;
const VK_BACK_SPACE     = 0x08;
const VK_TAB            = 0x09;
const VK_CLEAR          = 0x0C;
const VK_RETURN         = 0x0D;
const VK_ENTER          = 0x0E;
const VK_ESCAPE         = 0x1B;
const VK_SPACE          = 0x20;
const VK_PAGE_UP        = 0x21;
const VK_PAGE_DOWN      = 0x22;
const VK_END            = 0x23;
const VK_HOME           = 0x24;
const VK_LEFT           = 0x25;
const VK_UP             = 0x26;
const VK_RIGHT          = 0x27;
const VK_DOWN           = 0x28;
const VK_DELETE         = 0x2E;
const VK_QUOTE          = 34; //0xDE nsIDOMKey Event value not returned;
const VK_AMP          	= 38; 
const VK_LT          	= 60; 
const VK_GT          	= 62;


var outerWindow;
var openTool;
var xulapp;
var schema;

var transactionManager = new TransactionManager();
var oldTextValue = null;

function OnLoad(event) {
	// Note: outerWindow is not available here.
	document.getElementById = getElementById;
}
function OnLoadOuter(aWindow, aOpenTool, aXulapp) {
	outerWindow = aWindow;
	openTool = aOpenTool;
	xulapp = aXulapp;

transactionManager.maxTransactionCount = -1; // No limit
}
function OnClick(event) {
	var node = event.target.parentNode;
	if (node.nodeType == NODE_TYPE_ELEMENT) {
		// make it easier to hit empty attribute values.
		if (node.localName == "qts") 
			node.nextSibling.focus();
		else
		if (node.localName == "qte") 
			node.previousSibling.focus();
		// make it easier to hit empty internalsubset values.
		else	
		if (node.localName == "dtxs") 
			node.nextSibling.focus();
		else
		if (node.localName == "dtxe") 
			node.previousSibling.focus();
	}
	if (event.detail == 2) {
		// Extend selection to complete item
		var selection = window.getSelection();
		if (	node.localName == "av" ||
				node.localName == "at" ||												
				node.localName == "el" ||
				node.localName == "en" ||
				node.localName == "pi" ||
				node.localName == "pn" ||
				node.localName == "cd" ||
				node.localName == "dt" ||
				node.localName == "cm" ) {
			selection.selectAllChildren(node);
			event.preventBubble();
		}
		else
		if (	node.localName == "ele" ||
				node.localName == "cms" ||
				node.localName == "cmx" ||	
				node.localName == "cme" ||
				node.localName == "cds" ||
				node.localName == "cde" ) {
			selection.selectAllChildren(node.parentNode);
			event.preventBubble();
		}
	}	
}

function OnFocus(event) {
	var node = event.target;
	if (node.nodeType == NODE_TYPE_ELEMENT) {
		if (isInputElement(node)) {
			//scrollBoxObject.scrollToElement(node);
			oldTextValue = node.firstChild.nodeValue;
			//scrollBoxObject.ensureElementIsVisible(node);
		}	
	}
}

function OnBlur(event) {
}

function OnKeyPress(event) {
	var tran;
	var node = event.target;
	if (event.ctrlKey || event.altKey || event.metaKey ) {
		return;
	}	
	switch (event.keyCode) {
	case VK_UP:
	case VK_DOWN:
	case VK_HOME:
	case VK_END:
	case VK_PAGE_DOWN:
	case VK_PAGE_UP:
	case VK_TAB: //TODO add other control keys which should be ignored.
		return;
	}
	
	if (node.nodeType == NODE_TYPE_ELEMENT) {
		if (isInputElement(node)) {
			var selection = window.getSelection();
			if (selection.anchorNode == selection.focusNode) {
				var textNode = node.firstChild;
				var from = selection.anchorOffset;
				var to	= selection.focusOffset;
				if (from > to) {
					from = selection.focusOffset;
					to	= selection.anchorOffset;
				}
				switch (event.keyCode) {
				case VK_RIGHT:
					if (!event.shiftKey) {
						if (to < textNode.nodeValue.length)
							to++;
						selection.collapse(textNode, to);
					}	
					break;
				case VK_LEFT:
					if (!event.shiftKey) {
						if (to > 0) 
							to--;
						selection.collapse(textNode, to);
					}	
					break;
				case VK_BACK_SPACE:
					if (from == to) {
						from--;
						if (from < 0)
							return;
					}	
					textNode.nodeValue = textNode.nodeValue.substr(0,from)
												+ textNode.nodeValue.substr(to);
					selection.collapse(textNode, from);
					break;
				case VK_DELETE:
					if (from == to) {
						if (to > textNode.nodeValue.length)
							return;
						to++;
					}	
					textNode.nodeValue = textNode.nodeValue.substr(0,from)
												+ textNode.nodeValue.substr(to);
					selection.collapse(textNode, from);
					break;
				case VK_ENTER:
				case VK_RETURN:
					textNode.nodeValue = textNode.nodeValue.substr(0,from)
												+ "\n" 
												+ textNode.nodeValue.substr(to);
					selection.collapse(textNode, from+1);											
					break;
				default:
					if (event.charCode == 0) // non-typeable character NumKey etc.
						return;
					var chars;
					if (node.localName == "av" || node.localName == "tx")
						chars = mapEntities(event);
					else
						chars = String.fromCharCode(event.charCode);
					textNode.nodeValue = textNode.nodeValue.substr(0,from)
												+ chars 
												+ textNode.nodeValue.substr(to);
					selection.collapse(textNode, from + chars.length);											
				}
				// Implement merge - its broken as of 0.9.9
				var isMerged = false;
				if (transactionManager.numberOfUndoItems > 0) {
					tran = transactionManager.peekUndoStack();
					if (tran && (tran instanceof ValueTransaction)) {
						if (tran.focusNode == node) {
							tran.newValue = textNode.nodeValue;
							isMerged = true;
						}
					}
				}
				if (!isMerged) {
					tran = new ValueTransaction(node, textNode.nodeValue, oldTextValue)
					transactionManager.doTransaction(tran);
				}	
				outerWindow.onTransaction(transactionManager);
				// copy changes to element name to end tag (if any)
				if (node.localName == "en") {
					var el = node.parentNode;
					var et = el.lastChild;
					if (et.localName == "et") {
						et.firstChild.nextSibling.firstChild.nodeValue = textNode.nodeValue;
					}
				}
			}
		}
		else { // not input element
			if (event.keyCode == VK_DELETE) {
				node = outerWindow.getElFromViewNode(node);
				switch (node.nodeName) {
				case "el":
				case "cm":
				case "pi":
				case "cd":
				case "dt":
					var cmd = {};
					cmd.insertInto = false;
					cmd.what = getItemType(node);
					cmd.focusNode = node;
					cmd.inverse = true;
					if (cmdProlog(cmd)) {
						var nextFocusNode = node.nextSibling.nextSibling;
						tran = new ViewNodeTransaction(cmd.parentNode, cmd.beforeNode, node, cmd.focusNode, nextFocusNode, true);
						transactionManager.doTransaction(tran);
						outerWindow.onTransaction(transactionManager);
					}	
					break;
				case "at":
					break;
				}
			}	
		}
	}	
}

function mapEntities(event) {
	switch (event.charCode) {
	case VK_LT:
		return "&lt;";
	case VK_GT:
		return "&gt;";
	case VK_QUOTE:
		return "&quot;";
	case VK_AMP:
		if (!event.altKey)
			return "&amp;";
	}
	return String.fromCharCode(event.charCode);
}
function OnKeyDown(event) {
	var xLeft;
	var yTop;
	switch (event.keyCode) {
	case VK_UP:
		//scrollBoxObject.scrollByLine(-1);
		return;
	case VK_DOWN:
		//scrollBoxObject.scrollByLine(1);
		return;
	case VK_HOME:
	/*
		if (event.ctrlKey) {
			scrollTo(0, 0);
			return;	
		}
		yTop = getY();
		scrollTo(0, yTop);
	*/
		return;
	case VK_END:
		if (event.ctrlKey) {
			xLeft = getX();
			//scrollTo(xLeft, desc.boxObject.height - scrollBox.boxObject.height);
			return;
		}
		yTop = getY();
		//scrollTo(desc.boxObject.width - scrollBox.boxObject.width, yTop);
  		return;
	case VK_PAGE_DOWN:
		if (event.ctrlKey) {
			yTop = getY();
			xLeft = getX();
			//scrollTo(xLeft + scrollBox.boxObject.width, yTop);
			return;
		}	
		yTop = getY();
		xLeft = getX();
		//scrollTo(xLeft, yTop + scrollBox.boxObject.height);
		return;
	case VK_PAGE_UP:
		if (event.ctrlKey) {
			yTop = getY();
			xLeft = getX();
			//scrollTo(xLeft - scrollBox.boxObject.width, yTop);
			return;
		}	
		yTop = getY();
		xLeft = getX();
		//scrollTo(xLeft, yTop - scrollBox.boxObject.height);
		return;
	}
}
function getNextInputNode(aNode) {
	var nextNode = aNode.nextSibling;
	while (nextNode) {
		if (nextNode.nodeName == "av" || nextNode.nodeName == "an")
			return nextNode;
		nextNode = nextNode.nextSibling;
	}
	return null;
}
function getX() {
  //scrollBoxObject.getPosition(X, Y);
  return Math.floor(X.value/TWIPS);
}
function getY() {
  //scrollBoxObject.getPosition(X, Y);
  return Math.floor(Y.value/TWIPS);
}
function scrollTo(x, y) {
	var xMax = Math.max(desc.boxObject.width - scrollBox.boxObject.width,0);
	var yMax = Math.max(desc.boxObject.height - scrollBox.boxObject.height,0);
	x = Math.max(x, 0);
	x = Math.min(xMax, x);
	y = Math.max(y, 0);
	y = Math.min(yMax, y);
	x *= TWIPS; // The twerps use twips!
	y *= TWIPS; 
	//debug("scrollTo: descH:" + desc.boxObject.height + " sbH:" + scrollBox.boxObject.height + " x:" + x + " y:" + y);
	scrollBoxObject.scrollTo(x, y);
}

function expand(event, id) {
	var el = document.getElementById(id);
	var exp = outerWindow.getExpFromEl(el);
	var et = exp.nextSibling;
	var visibility = document.defaultView.getComputedStyle(exp, '' ).getPropertyValue("display");	
	if (visibility=="block") {
		exp.setAttribute("style", "display:none");
		event.target.removeAttribute("open");
		et.setAttribute("style", "display:none");
	}	
	else {	
		exp.setAttribute("style", "display:block");
		event.target.setAttribute("open", true);
		et.setAttribute("style", "display:block");
	}	
}
function expandComment(event, id) { // Note also used for cdata
	var cm = document.getElementById(id);
	var cx;
	if (cm.nodeName == "cm")
		cx = outerWindow.getCxFromCm(cm);
	else
		cx = outerWindow.getCdxFromCd(cm);
		// note can't check computed style for white-space as not available as of 2002030303
	if (cx.hasAttribute("open")) {
		cx.setAttribute("style", "white-space:nowrap !important;");
		cx.removeAttribute("open");
		event.target.setAttribute("src", TWISTY_CLOSED);
	}	
	else {	
		cx.setAttribute("style", "white-space:pre !important;");
		cx.setAttribute("open", "true");
		event.target.setAttribute("src", TWISTY_OPEN);
	}	
}
function expandAttributes(event, id) {
	if (event.altKey && (event.keyCode == VK_ENTER || event.keyCode == VK_RETURN) ) {
		var el = document.getElementById(id);
		var ats = outerWindow.getAtsFromEl(el);
		// note can't check computed style for white-space as not available as of 2002030303
		if (ats.hasAttribute("open")) {
			ats.setAttribute("style", "white-space:nowrap !important;");
			ats.removeAttribute("open");
		}	
		else {	
			ats.setAttribute("style", "white-space:pre !important;");
			ats.setAttribute("open", "true");
		}
		event.preventDefault();
	}	
}

var widgetObserver = {
	
	prevTarget: 		null,
	prevCtrlKey: 		0,
	prevCanDrop: 		false,
	dropParent: 		null,
	dropBefore: 		null, // May remain null for ACTION_ON
	dropAction: 		null,
	dragSourceWindow:	null,
	dragNodeType: 		null,
	dragToolId:			null,


	getSupportedFlavours : function () {
		var flavours = new FlavourSet();
		flavours.appendFlavour(MIMETYPE_NEW_ITEM);
		flavours.appendFlavour(MIMETYPE_OLD_ITEM);
		flavours.appendFlavour(MIMETYPE_TEXT);
		return flavours;
	},
	onDragStart: function (event, transferData, action){
		var selection = window.getSelection();
		if (selection.anchorNode == selection.focusNode) {
			var dragNode = selection.anchorNode;
			var dargNodeType = "";
			var el = null;
			switch (dragNode.nodeName) {
			case "el":
				dragNodeType = ITEMTYPE_ELEMENT;
				break;
			case "at":
				dragNodeType = ITEMTYPE_ATTRIBUTE;
				break;
			case "cm":
				dragNodeType = ITEMTYPE_COMMENT;
				break;
			default:
				event.stopPropagation()			
				throw "not draggable";
			}
			xulapp.dropData = {dragSourceWindow:window, dragNode: dragNode, dragNodeType:dragNodeType };
	    	transferData.data=new TransferData();
	    	transferData.data.addDataForFlavour(MIMETYPE_OLD_ITEM, "see xulapp.dropData");
	    	return;
		}
		event.stopPropagation()		
		throw "not draggable";
	},
	
	onDragOver: function (event, flavour, session){
		try {
			//debug("DO:" + event.target.nodeName + " parent:" + event.target.parentNode.nodeName);
		}
		catch (e) {}
		// we need to cache dragover state as finding out whether we can drop is expensive (and very frequent).
		// Same target same control key, same result.
		if (event.target == this.prevTarget && event.ctrlKey == this.prevCtrlKey) {
			session.canDrop = this.prevCanDrop;
			event.preventDefault();
			return;
		}	
		this.prevTarget = event.target;
		this.prevCtrlKey = event.ctrlKey;

		// Now get the transfer data.
		if (!this.setDropData(session, flavour)) {
			this.prevCanDrop = false;
			session.canDrop = false; 
			event.preventDefault();
			return;		
		}
		
		if (!this.setDropTarget(event)) {
			session.canDrop = false;
			this.prevCanDrop = false;
			event.preventDefault();
			return;
		}

		// Prelim check to see if we are even remotely droppable.
		// Syntax only - no semantic checks.
		if (!canPutHere(this.dropParent, this.dropAction, this.dragNodeType)) {
			session.canDrop = false;
			this.prevCanDrop = false;
			event.preventDefault();
			return;
		}
		//debug("Dragdata:" + this.toolId +
		//		" nodetype:" + this.dragNodeType +
		//		" canDrop:" + session.canDrop +
		//		" parent:" + this.dropParent.nodeName +
		//		" before:" + ((this.dropBefore)?this.dropBefore.nodeName:"null") +
		//		" action:" + this.dropAction);
				
		// show dragover line.
		if (session.canDrop && event.target.nodeName == "hr") 
			event.target.setAttribute("dragover","true");
			
		this.prevCanDrop = session.canDrop;
		event.preventDefault();
	},
	
	onDragExit: function (event, session) {
		if (event.target.nodeName == "hr") {
			event.target.removeAttribute("dragover");
			session.canDrop = false;
			return; 
		}	
	},
	
	onDrop: function (event, dropdata, session){
		this.prevTarget = null;
		this.prevCtrlKey =	0;
		this.prevCanDrop =	false;
		if (!this.dropParent)
			return;
		//debug("Dropdata:" + this.toolId +
		//		" nodetype:" + this.dragNodeType +
		//		" parent:" + this.dropParent.nodeName +
		//		" before:" + ((this.dropBefore)?this.dropBefore.nodeName:"null") +
		//		" action:" + this.dropAction);
		switch (dropdata.flavour.contentType) {
		case MIMETYPE_NEW_ITEM:
		case MIMETYPE_TEXT:
			insertNewItem(event, this);
			break;
		case MIMETYPE_OLD_ITEM:
			insertOldItem(event, this, session);
			break
		}
	},
	
 	setDropData: function(session, flavour) {
 		switch (flavour.contentType) {
 		case MIMETYPE_TEXT:
			//TODO parse as CDATA, PCDATA or attribute (eventually complete element).
			this.dragNodeType = ITEMTYPE_PLAINTEXT
			//dropData unchanged.
			return true;
 		case MIMETYPE_NEW_ITEM:
			this.dragSourceWindow = xulapp.dropData.dragSourceWindow;
			this.dragNodeType = xulapp.dropData.dragNodeType;
			this.dragToolId = xulapp.dropData.dragToolId;
			return true;
 		case MIMETYPE_OLD_ITEM:
			this.dragSourceWindow = xulapp.dropData.dragSourceWindow;
			this.dragNodeType = xulapp.dropData.dragNodeType;
			this.dragNode = xulapp.dropData.dragNode;
			return true;
 		default:
 			return false;
 		}
	},

 	setDropTarget: function(event) {
		// inter line selector
		if (event.target.nodeName == "hr") {
			this.dropAction = ACTION_BEFORE;
			this.dropParent = event.target.parentNode;
			this.dropBefore = event.target.nextSibling;
			if (this.dropParent.nodeName == "exp")
				this.dropParent = this.dropParent.parentNode;
			return (this.dropParent);	
		}
		// Any text node.
		if (event.target.nodeName == "#text") {
			var dropNode = event.target.parentNode;
			this.dropParent = dropNode;
			if (this.dragNodeType == ITEMTYPE_ATTRIBUTE) {
				var el = outerWindow.getElFromViewNode(dropNode);
				this.dropParent = outerWindow.getAtsFromEl(el);
				this.dropAction = ACTION_BEFORE;
				if (dropNode.nodeName == "en")
					this.dropBefore = null;
				else
					this.dropBefore = outerWindow.getAtFromAn(dropNode);
			}
			else {
				this.dropAction = ACTION_ON;
				this.dropBefore = null;
				if (this.dragNodeType != ITEMTYPE_PLAINTEXT) 
					this.dropParent = outerWindow.getElFromViewNode(this.dropParent);	
			}		
			return (this.dropParent);
		}
		return false;
	}
};

function insertNewItem(event, dnd) {
	var tran;
	var selection = window.getSelection();
	var focusNode = selection.focusNode;
	if (focusNode) {
		if (focusNode.nodeName == "#text")	
			focusNode = focusNode.parentNode;
	}		
	var viewNode;
	var newFocusNode;
	switch (dnd.dragNodeType) {
	//TODO attribute.
	case ITEMTYPE_ELEMENT:
		viewNode = outerWindow.createViewElement(DFT_ELEM_NAME);
		newFocusNode = outerWindow.getEnFromEl(viewNode);
		break;
	case ITEMTYPE_ATTRIBUTE:
		var el = outerWindow.getElFromViewNode(dnd.dropParent);
		var equalsRequired = (el.localName != "dt");	
		var viewAttr = outerWindow.createViewAttribute(DFT_ATTR_NAME, DFT_ATTR_VALUE, equalsRequired);
		tran = new AttributeTransaction(el, dnd.beforeNode, viewAttr, focusNode, false);
		transactionManager.doTransaction(tran);
		outerWindow.onTransaction(transactionManager);
		return;
	case ITEMTYPE_PCDATA:
		viewNode = outerWindow.createViewText(DFT_PCDATA_VALUE);
		newFocusNode = viewNode;
		break;
	case ITEMTYPE_CDATA:
		viewNode = outerWindow.createViewCDATA(DFT_CDATA_VALUE);
		newFocusNode = outerWindow.getCdxFromCd(viewNode);
		break;
	case ITEMTYPE_COMMENT:
		viewNode = outerWindow.createViewComment(DFT_COMMENT_VALUE);
		newFocusNode = outerWindow.getCxFromCm(viewNode);
		break;
	case ITEMTYPE_PI:
		viewNode = outerWindow.createViewPI(DFT_PI_NAME, DFT_ATTR_VALUE);
		newFocusNode = outerWindow.getPnFromPi(viewNode);
		break;
	case ITEMTYPE_DOCTYPE:
		viewNode = outerWindow.createViewDocType(DFT_ATTR_NAME, "", DFT_ATTR_NAME, "");
		newFocusNode = outerWindow.getPnFromPi(viewNode);
		break;
	case ITEMTYPE_PLAINTEXT:
		debug("PTXT DROP:" + event.rangeParent + "?" + event.rangeOffset);
		return;
	default:
		return;
	}
	tran = new ViewNodeTransaction(dnd.dropParent, dnd.dropBefore, viewNode, newFocusNode, focusNode, false);
	transactionManager.doTransaction(tran);
	outerWindow.onTransaction(transactionManager);
}
function insertOldItem(event, dnd, session) {
	var selection = window.getSelection();
	var focusNode = selection.focusNode;
	if (focusNode) {
		if (focusNode.nodeName == "#text")	
			focusNode = focusNode.parentNode;
	}
	var newFocusNode = null;
	switch (dnd.dragNode.nodeName) {
	case "el":
		newFocusNode = outerWindow.getEnFromEl(dnd.dragNode);
		break;
	case "at":
		newFocusNode = outerWindow.getAnFromAt(dnd.dragNode);
		break;
	case "cm":
		newFocusNode = outerWindow.getCxFromCm(dnd.dragNode);
		break;
	case "cd":
		newFocusNode = outerWindow.getCdxFromCd(dnd.dragNode);
		break;
	default:
		event.stopPropagation()			
		throw "not draggable";
	}
	var dragNodeClone;
	var tran;
	if (window === dnd.dragSourceWindow) {
		if (session.dragAction == DRAGDROP_ACTION_MOVE) {
			//srcsamewindow move batch removeold insertNew endbatch 
			transactionManager.beginBatch();
				//parentNode, beforeNode, viewNode, focusNode, prevFocusNode, inverse
				var oldParent = outerWindow.getParentFromViewNode(dnd.dragNode);
				var oldBefore = dnd.dragNode.nextSibling.nextSibling;
				tran = new ViewNodeTransaction(oldParent, oldBefore, dnd.dragNode, null, focusNode, true);
				transactionManager.doTransaction(tran);
				tran = new ViewNodeTransaction(dnd.dropParent, dnd.dropBefore, dnd.dragNode, newFocusNode, focusNode, false);
				transactionManager.doTransaction(tran);
			transactionManager.endBatch();
			
		}
		else {
			//srcsamewindow copy insertNew
			dragNodeClone = dnd.dragNode.cloneNode(true);
			outerWindow.reNumber(dragNodeClone);
			tran = new ViewNodeTransaction(dnd.dropParent, dnd.dropBefore, dragNodeClone, newFocusNode, focusNode, false);
			transactionManager.doTransaction(tran);
		}
	}
	else {
		if (session.dragAction == DRAGDROP_ACTION_MOVE) {
			//srcdiffwindow move Notify other window to remove old. insertNew with new ids.
		}
		else {
			//srcdiffwindow copy insertNew
			dragNodeClone = dnd.dragNode.cloneNode(true);
			tran = new ViewNodeTransaction(dnd.dropParent, dnd.dropBefore, dragNodeClone, newFocusNode, focusNode, false);
			transactionManager.doTransaction(tran);
		}
	}
	outerWindow.onTransaction(transactionManager);
}

function cmdUndo() {
	transactionManager.undoTransaction();
	outerWindow.onTransaction(transactionManager);
}

function cmdRedo() {
	transactionManager.redoTransaction();
	outerWindow.onTransaction(transactionManager);
}

function cmdInsertComment(insertInto) {
	cmd = {};
	cmd.insertInto = insertInto;
	cmd.what = ITEMTYPE_COMMENT;
	cmd.inverse = false;
	cmd.focusNode = window.getSelection().focusNode;
	
	if (cmdProlog(cmd)) {
		var cm = outerWindow.createViewComment(DFT_COMMENT_VALUE);
		var cx = outerWindow.getCxFromCm(cm);
		var tran = new ViewNodeTransaction(cmd.parentNode, cmd.beforeNode, cm, cx, cmd.focusNode, false);
		transactionManager.doTransaction(tran);
		outerWindow.onTransaction(transactionManager);
	}	
}

function cmdInsertPI() {
	cmd = {};
	cmd.insertInto = false;
	cmd.what = ITEMTYPE_PI;
	cmd.inverse = false;
	cmd.focusNode = window.getSelection().focusNode;
	if (cmdProlog(cmd)) {
		var pi = outerWindow.createViewPI(DFT_PI_NAME, DFT_ATTR_VALUE);
		var pn = outerWindow.getPnFromPi(pi);
		var tran = new ViewNodeTransaction(cmd.parentNode, cmd.beforeNode, pi, pn, cmd.focusNode, false);
		transactionManager.doTransaction(tran);
		outerWindow.onTransaction(transactionManager);
	}	
}

function cmdInsertElement(insertInto) {
	cmd = {};
	cmd.insertInto = insertInto;
	cmd.what = ITEMTYPE_ELEMENT;
	cmd.inverse = false;
	cmd.focusNode = window.getSelection().focusNode;
	if (cmdProlog(cmd)) {
		var newEl = outerWindow.createViewElement(DFT_ELEM_NAME);
		var en = outerWindow.getEnFromEl(newEl);
		var tran = new ViewNodeTransaction(cmd.parentNode, cmd.beforeNode, newEl, en, cmd.focusNode, false);
		transactionManager.doTransaction(tran);
		outerWindow.onTransaction(transactionManager);
	}	
}

function cmdInsertAttribute() {
	var selection = window.getSelection();
	var focusNode = selection.focusNode;
	if (!focusNode)
		return;
	var viewNode = focusNode.parentNode;	
	if (	viewNode.localName == "en" ||
			viewNode.localName == "an" ||
			viewNode.localName == "av"	) {
		var el = outerWindow.getElFromViewNode(viewNode);
		if (!el)
			return;
		var equalsRequired = (el.localName != "dt");	
		var viewAttr = outerWindow.createViewAttribute(DFT_ATTR_NAME,DFT_ATTR_VALUE, equalsRequired);
		var beforeAttr;
		// We want insert after - so find the next at viewNode to insert before.
		if (viewNode.localName == "en") 
			beforeAttr = outerWindow.getAtsFromEl(el).firstChild;
		else // hack alert getAtFromAv === getAtFromAn
			beforeAttr = outerWindow.getAtFromAn(viewNode).nextSibling;
		var tran = new AttributeTransaction(el, beforeAttr, viewAttr, focusNode, false);
		transactionManager.doTransaction(tran);
		outerWindow.onTransaction(transactionManager);
	}
}

function cmdInsertText(insertInto) {
	cmd = {};
	cmd.insertInto = insertInto;
	cmd.what = ITEMTYPE_PCDATA;
	cmd.inverse = false;
	cmd.focusNode = window.getSelection().focusNode;
	if (cmdProlog(cmd)) {
		var tx = outerWindow.createViewText(DFT_PCDATA_VALUE);
		var tran = new ViewNodeTransaction(cmd.parentNode, cmd.beforeNode, tx, tx, cmd.focusNode, false);
		transactionManager.doTransaction(tran);
		outerWindow.onTransaction(transactionManager);
	}	
}

function cmdInsertCDATA(insertInto) {
	cmd = {};
	cmd.insertInto = insertInto;
	cmd.what = ITEMTYPE_CDATA;
	cmd.inverse = false;
	cmd.focusNode = window.getSelection().focusNode;
	if (cmdProlog(cmd)) {
		var cd = outerWindow.createViewCDATA(DFT_CDATA_VALUE);
		var cdx = outerWindow.getCdxFromCd(cd);
		var tran = new ViewNodeTransaction(cmd.parentNode, cmd.beforeNode, cd, cdx, cmd.focusNode, false);
		transactionManager.doTransaction(tran);
		outerWindow.onTransaction(transactionManager);
	}	
}
function cmdProlog(cmd) {
	if (!cmd.focusNode)
		return false;
	if (cmd.focusNode.nodeName == "#text")	
		cmd.focusNode = cmd.focusNode.parentNode;
	var el = outerWindow.getElFromViewNode(cmd.focusNode);
	if (!el)
		return false;
		
	cmd.parentNode = el;
	cmd.beforeNode = null;
	if (!cmd.insertInto) {	
		cmd.parentNode = el.parentNode;
		if (cmd.parentNode.nodeName == "exp")
			cmd.parentNode = cmd.parentNode.parentNode;
		cmd.beforeNode = el.nextSibling;
		if (cmd.beforeNode && cmd.beforeNode.nodeName == "hr")
			cmd.beforeNode = cmd.beforeNode.nextSibling;
	}
	return canPutHere(cmd.parentNode, (cmd.inverse?ACTION_REMOVE:ACTION_BEFORE), cmd.what);
}

function	canPutHere(parentNode, action, what) {
	switch (what) {
	case ITEMTYPE_COMMENT:
		return (parentNode.nodeName == "el" || action != ACTION_ON);
	case ITEMTYPE_ELEMENT:
		// If no document element then allow anywhere
		// TODO should be after doctype (if any)
		if (document.getElementById("DOCELEM") == null)
			return (parentNode.nodeName == "el" || action != ACTION_ON);
		// No more top level elements.	
		if (parentNode.nodeName == "BODY")
			return false; 
		// Allow drop on element or before anthing else.	
		return ( (parentNode.nodeName == "el" && action == ACTION_ON) ||
					action != ACTION_ON);
	case ITEMTYPE_ATTRIBUTE:
		return (parentNode.nodeName == "ats" && action == ACTION_BEFORE); 
	case ITEMTYPE_PI:
		// anywhere on top level.
		return (parentNode.nodeName == "BODY" && action != ACTION_ON);
	case ITEMTYPE_PCDATA:
	case ITEMTYPE_CDATA:
		// Top level not allowed.	
		if (parentNode.nodeName == "BODY")
			return false; 
		// Allow drop on element or before anthing else.
		return ( (parentNode.nodeName == "el" && action == ACTION_ON) ||
					action != ACTION_ON);
	case ITEMTYPE_PLAINTEXT:
		return isInputElement(parentNode);	
	case ITEMTYPE_DOCTYPE:
		// only one document type.
		if (action != ACTION_REMOVE && document.getElementById("DOCTYPE") != null)
			return false;
		// only top level.	
		if (parentNode.nodeName != "BODY")
			return false;
		// TODO must preceed document element.
		return true;
	}
	return false;
}
function isInputElement(viewNode) {
	return ( viewNode.localName == "av" ||
				viewNode.localName == "an" ||
				viewNode.localName == "en" ||
				viewNode.localName == "pn" || 
				viewNode.localName == "pv" || 
				viewNode.localName == "tx" || 
				viewNode.localName == "cdx" || 
				viewNode.localName == "cx"); 
}


function ValueTransaction(focusNode, newValue, oldValue) {
	this.focusNode = focusNode;
	this.newValue = newValue;
	this.oldValue = oldValue; // use null if added for first time.
	this.isTransient = false;
}

ValueTransaction.prototype.doTransaction = function() {
	//nothing to do
}
ValueTransaction.prototype.undoTransaction = function() {
	this.focusNode.firstChild.nodeValue = this.oldValue;
	// Undo end tag name if present.
	if (this.focusNode.localName == "en") {
		var el = this.focusNode.parentNode;
		var et = el.lastChild;
		if (et.localName == "et") {
			et.firstChild.nextSibling.firstChild.nodeValue = this.oldValue;
		}
	}
	//scrollBoxObject.ensureElementIsVisible(this.focusNode);
	this.focusNode.focus();
}
ValueTransaction.prototype.redoTransaction = function() {
	this.focusNode.firstChild.nodeValue = this.newValue;
	// Undo end tag name if present.
	if (this.focusNode.localName == "en") {
		var el = focusNode.parentNode;
		var et = el.lastChild;
		if (et.localName == "et") {
			et.firstChild.nextSibling.firstChild.nodeValue = this.newValue;
		}
	}
	//scrollBoxObject.ensureElementIsVisible(this.focusNode);
	this.focusNode.focus();
}
ValueTransaction.prototype.merge = function(aTransaction) {
	if (aTransaction instanceof ValueTransaction) {
		if (this.focusNode == aTransaction.focusNode) {
			this.newValue = aTransaction.newValue;
			return true;
		}
	}
	return false; //Merge not supported.
}

function AttributeTransaction(el, beforeAttr, viewAttr, prevFocusNode, inverse) {
	this.el = el;
	this.viewAttr = viewAttr;
	this.beforeAttr = beforeAttr;
	this.prevFocusNode = prevFocusNode;
	this.inverse = inverse;
	this.isTransient = false;
}
AttributeTransaction.prototype.doTransaction = function() {
	this.redoTransaction();
}
AttributeTransaction.prototype.undoTransaction = function() {
	if (!this.inverse)
		this.undoInternal();
	else	
		this.redoInternal();
}
AttributeTransaction.prototype.redoTransaction = function() {
	if (!this.inverse)
		this.redoInternal();
	else	
		this.undoInternal();
}
AttributeTransaction.prototype.undoInternal = function() {
	outerWindow.removeViewAttribute(this.viewAttr);
	if (this.prevFocusNode && this.prevFocusNode.focus)
		this.prevFocusNode.focus();
}
AttributeTransaction.prototype.redoInternal = function() {
	outerWindow.insertViewAttribute(this.el, this.viewAttr, this.beforeAttr);
	var an = outerWindow.getAnFromAt(this.viewAttr);
	an.focus();
	// Now select all of contents
	var selection = window.getSelection();
	selection.collapse(an, 0);
	selection.extend(an,an.firstChild.nodeValue.length);
}
AttributeTransaction.prototype.merge = function(aTransaction) {
	return false; //Merge not supported.
}

function ViewNodeTransaction(parentNode, beforeNode, viewNode, focusNode, prevFocusNode, inverse) {
	this.inverse = inverse;
	this.parentNode = parentNode;
	this.beforeNode = beforeNode; // this is the node before which to insert.
	this.viewNode = viewNode;
	this.focusNode = focusNode;
	this.prevFocusNode = prevFocusNode;
	this.isTransient = false;
}

ViewNodeTransaction.prototype.doTransaction = function() {
	this.redoTransaction();
}
ViewNodeTransaction.prototype.undoTransaction = function() {
	if (!this.inverse)
		this.undoInternal();
	else	
		this.redoInternal();
}
ViewNodeTransaction.prototype.redoTransaction = function() {
	if (!this.inverse)
		this.redoInternal();
	else	
		this.undoInternal();
}
ViewNodeTransaction.prototype.merge = function(aTransaction) {
	return false; //Merge not supported.
}
ViewNodeTransaction.prototype.undoInternal = function() {
	outerWindow.removeViewElement(this.viewNode);
	if (this.prevFocusNode && this.prevFocusNode.focus)
		this.prevFocusNode.focus();
}
ViewNodeTransaction.prototype.redoInternal = function() {
	outerWindow.insertViewElement(this.parentNode, this.viewNode, this.beforeNode);
	if (this.focusNode && this.focusNode.focus) {
		this.focusNode.focus();
		// Now select all of contents
		var selection = window.getSelection();
		selection.collapse(this.focusNode, 0);
		selection.extend(this.focusNode, this.focusNode.firstChild.nodeValue.length);
	}	
}
function getItemType(viewNode) {
	switch (viewNode.nodeName) {
	case "el": return ITEMTYPE_ELEMENT;
	case "at": return ITEMTYPE_ATTRIBUTE;
	case "cm": return ITEMTYPE_COMMENT;
	case "tx": return ITEMTYPE_PCDATA;
	case "cd": return ITEMTYPE_CDATA;
	case "pi": return ITEMTYPE_PI;
	case "dt": return ITEMTYPE_DOCTYPE;
	default:	  return ITEMTYPE_PLAINTEXT;
	}
}
function getElementById(id) {

	var nodelist = this.getElementsByTagName("*");
	for (var i=0; i < nodelist.length; i++) {
		var idAttr = nodelist[i].getAttribute("id");
		if (!idAttr) continue;
		if (idAttr == id) {
			return nodelist[i];
		}	
	}
	return null;
}





