/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is XulApp IDE.
 *
 * The Initial Developer of the Original Code is Synesis Software (USA) Inc.
 *

 * Portions created by the Initial Developer are Copyright (C) 2001-2005
 * Synesis Software (USA) Inc. the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * 	Peter Wilson, orignal author.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the LGPL or the GPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 *
 * ***** END LICENSE BLOCK ***** */
 
netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
var xulapp = window.arguments[0];
var openTool = window.arguments[1];

const XHTML = "http://www.w3.org/1999/xhtml";
const XUL = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
const	TWISTY_OPEN = "chrome://global/skin/tree/twisty-open.png";
const	TWISTY_CLOSED = "chrome://global/skin/tree/twisty-clsd.png";


var expandLevel = 2;
var currentLevel;
var RE_Whitespace = /^\s*$/;
var lastNodeIndex = 0; // nodeId = "N" + index. except for documentElement and DOCTYPE
var X = {};
var Y = {};

var xmlBrowser;
var innerWindow;
var innerDocument;


const DRAGDROP_ACTION_NONE = 0;
const DRAGDROP_ACTION_COPY = 1;
const DRAGDROP_ACTION_MOVE = 2;
const DRAGDROP_ACTION_LINK = 4;
var atTemplate;

const CTR_EMPTY		= 0;
const CTR_INLINE		= 1;
const CTR_BLOCK		= 2; 
const CTR_MIXED		= 4; 

var modelDom;
function OnLoad(event) {
	var loadMimeType;
	if (xulapp==undefined) return;
	setTitle();
	xmlBrowser = document.getElementById("xmlBrowser");
	innerWindow = xmlBrowser.contentWindow;
	innerDocument = xmlBrowser.contentDocument;
	
	atTemplate = makeAttributeTemplate();
	var re = /\.html$|\.htm$/
	if (re.test(openTool.fileURI)) 
		loadMimeType = "text/html";
	else
		loadMimeType = "text/xml";
		
	modelDom = Utility.loadDOMFromURI(loadMimeType, openTool.fileURI);
	OnDocLoadCallback();
	//modelDom = Utility.asyncLoadDOMFromURI(loadMimeType, openTool.fileURI, XUL, OnDocLoadCallback);
	innerWindow.OnLoadOuter(window, openTool, xulapp);

	var toolboxTemplate = new XSLTemplate("toolboxTemplate", xulapp.toolboxTools);
	toolboxTemplate.setStringParam("doctypefilter", openTool.extension.substr(1));
	toolboxTemplate.build();
	setViewDerivs();
}
var EmptySequence;
var Text;
var EmptyChoice;
var Pattern;
var datatypeLibraries;
function setViewDerivs() {
	// We are using relaxng objects and need to extend them with new methods.
	// The obvious way (defining them by including then in a script file does 
	// not work - the context is for the xulapp window not this one).
	// So grab the prototype objects from the correct context and amend accordingly.
	var protos = xulapp.schemas.getRelaxNGPrototypes();
	protos.Pattern.viewDeriv 				= PatternViewDeriv;
	protos.Start.viewDeriv 					= StartViewDeriv;
	protos.Ref.viewDeriv 					= RefViewDeriv;
	protos.Define.viewDeriv 				= DefineViewDeriv;
	protos.Element.viewDeriv 				= ElementViewDeriv;
	protos.Attribute.viewDeriv 			= AttributeViewDeriv;
	protos.OneOrMore.viewDeriv 			= OneOrMoreViewDeriv;
	protos.Choice.viewDeriv 				= ChoiceViewDeriv;
	protos.Sequence.viewDeriv  			= SequenceViewDeriv;
	protos.Interleave.viewDeriv 			= InterleaveViewDeriv;
	protos.Value.viewDeriv 					= ValueViewDeriv;
	protos.Data.viewDeriv 					= DataViewDeriv;
	protos.Text.viewDeriv 					= TextViewDeriv;
	protos.List.viewDeriv 					= ListViewDeriv;
	protos.EmptySequence.viewDeriv 		= EmptySequenceViewDeriv;
	protos.Attribute.matchViewNamespace = AttributeMatchViewNamespace;
	protos.Choice.matchViewNamespace 	= ChoiceMatchViewNamespace;
	protos.Element.matchViewNamespace	= ElementMatchViewNamespace;
	protos.Sequence.matchViewNamespace  = SequenceMatchViewNamespace;
	protos.Name.matchViewNamespace 		= NameMatchViewNamespace;
	protos.AnyName.matchViewNamespace 	= AnyNameMatchViewNamespace;
	protos.NSName.matchViewNamespace 	= NSNameMatchViewNamespace;
	protos.Except.matchViewNamespace 	= ExceptMatchViewNamespace;
	EmptySequence = protos.EmptySequenceObj;
	EmptyChoice = protos.EmptyChoiceObj;
	Text = protos.TextObj;
	Pattern = protos.PatternObj;
	datatypeLibraries	= protos.datatypeLibraries;

}

function OnDocLoadCallback(event) {
	var body = xmlBrowser.contentDocument.getElementById("body");
	body.appendChild(createViewXMLDecl(modelDom));
	insertDDMarker(body);
	buildView(modelDom, modelDom.firstChild, body, 1);
	modelDom = null;
	expandLevel = 99999;
}
function setTitle() {
	var ind = (openTool.isModified)? " + ":" - ";
	document.title = "JS Editor" + ind + File.URLToPath(openTool.fileURI);
}
function OnClose() {
	if (!openTool.mightSave()) 
		return false;
	return true;	
}
function OnUnload() {
	openTool.close();
}

function serialize() {
	var xmlDoc = DomFromDomView();
	var ser = new XULDOMSerializer(xulapp.project.xuloutput);
	ser.serialize(xmlDoc);
	return ser.XML;
	//return editor.value;
}

function OnClick(event) {
}

function OnSave () {
	if (openTool) {
		openTool.save();
		setTitle();
	}	
}

function OnSaveAs () {
	if (openTool) {
		openTool.saveAs();
		setTitle();
	}	
}

function buildView(modelDom, node, viewNode, level) {
	currentLevel = level;
	while (node) {
		switch (node.nodeType) {
		case NODE_TYPE_ELEMENT:
			var isDocumentElement = (node == modelDom.documentElement);
			var el = createViewElement(node.nodeName, isDocumentElement);
			buildViewAttributes(el, node);
			viewNode.appendChild(el);
			insertDDMarker(viewNode);
			var containerType = getContainerType(node);
			if (containerType >= CTR_BLOCK)	{
				var container = getElementContainer(el);
				buildView(modelDom, node.firstChild, container,level+1);
				currentLevel = level;
			}
			else {
				if (containerType == CTR_INLINE) {
					container = getElementContainer(el);
					buildView(modelDom, node.firstChild, container, level+1);
					currentLevel = level;
				}
			}			
			break;
		case NODE_TYPE_TEXT:
			var isWS = RE_Whitespace.test(node.nodeValue);
			if (!isWS) {
				var tx = createViewText(node.nodeValue);
				viewNode.appendChild(tx);
				insertDDMarker(viewNode);
			}
			break;
		case NODE_TYPE_CDATA:
			var cd = createViewCDATA(node.data);
			viewNode.appendChild(cd);
			insertDDMarker(viewNode);
			break;
		case NODE_TYPE_COMMENT:
			var cm = createViewComment(node.data);
			viewNode.appendChild(cm);
			insertDDMarker(viewNode);
			break;
		case NODE_TYPE_PROCESSING_INSTRUCTION:	
			var pi = createViewPI(node.target, node.data);
			viewNode.appendChild(pi);
			insertDDMarker(viewNode);
			break;
		case NODE_TYPE_DOCUMENT_TYPE:	
			var dt = createViewDocType(node.name, node.publicId, node.systemId, node.internalSubset);
			viewNode.appendChild(dt);
			insertDDMarker(viewNode);
			break;
		default:
		}
		node = node.nextSibling;
	}	
}
function createViewXMLDecl(dom) {
	// Somewhat limited until DOM 3 is implemented.
	var xml = innerDocument.createElementNS(XUL,"xml");
	xml.setAttribute("id","XMLDECL");
	xml.appendChild(innerDocument.createTextNode('<?xml version="1.0"?>'));
	return xml;
}
function createViewElement(nodeName, isDocumentElement) {
	var el = innerDocument.createElementNS(XUL,"el");
	var id;
	if (isDocumentElement) 
		id = "DOCELEM";
	else 
		id = getNextId();
	el.setAttribute("id",id);
	el.appendChild(innerDocument.createTextNode("<"));
	var en = innerDocument.createElementNS(XUL, "en");
		en.setAttribute("onkeypress", "expandAttributes(event, '" + id + "')");
		en.appendChild(innerDocument.createTextNode(nodeName));
	el.appendChild(en);
	var ats = innerDocument.createElementNS(XHTML, "ats"); // Container for attributes
	el.appendChild(ats);
	var ele = innerDocument.createElementNS(XUL,"ele");
	ele.appendChild(innerDocument.createTextNode("/>"));
	el.appendChild(ele);
	return el;	
}
function createViewText(nodeData) {
	var tx = innerDocument.createElementNS(XUL, "tx");	
	tx.appendChild(innerDocument.createTextNode(nodeData));			
	return tx;
}
function createViewCDATA(nodeData) {
	var cd = innerDocument.createElementNS(XUL,"cd");
	var id = getNextId();
	cd.setAttribute("id", id);
	var cds = innerDocument.createElementNS(XUL,"cds");	
	var pl = document.createElementNS(XUL, "image");
		pl.setAttribute("onclick", "expandComment(event, '" + id + "')");	
		pl.setAttribute("class","twisty");
		pl.setAttribute("align","baseline");
	cds.appendChild(pl);
	cds.appendChild(innerDocument.createTextNode("<![CDATA["));
	cd.appendChild(cds);
	var cdx = innerDocument.createElementNS(XUL, "cdx");
	cdx.appendChild(innerDocument.createTextNode(nodeData));
	cd.appendChild(cdx);
	var cde = innerDocument.createElementNS(XUL,"cde");	
		cde.appendChild(innerDocument.createTextNode("]]>"));
	cd.appendChild(cde);	
	return cd;
}
function createViewComment(nodeData) {
	var cm = innerDocument.createElementNS(XUL,"cm");
	var id = getNextId();
	cm.setAttribute("id", id);
	var cms = innerDocument.createElementNS(XUL,"cms");	
	var pl = document.createElementNS(XUL, "image");
		pl.setAttribute("onclick", "expandComment(event, '" + id + "')");	
		pl.setAttribute("class","twisty");
		pl.setAttribute("align","baseline");
	cms.appendChild(pl);
	cm.appendChild(cms);
	cm.appendChild(innerDocument.createTextNode("<-- "));
	var cx = document.createElementNS(XUL, "cx");
	cx.appendChild(innerDocument.createTextNode(nodeData));
	cm.appendChild(cx);
	cm.appendChild(innerDocument.createTextNode(" -->"));
	return cm;
}
function createViewPI(target, data) {
	var pi = innerDocument.createElementNS(XUL,"pi");
	pi.setAttribute("id",getNextId());
	pi.appendChild(innerDocument.createTextNode("<?"));
	var pn = innerDocument.createElementNS(XUL, "pn");
		pn.appendChild(innerDocument.createTextNode(target));
	pi.appendChild(pn);	
	pi.appendChild(innerDocument.createTextNode(" "));
	var pv = innerDocument.createElementNS(XUL, "pv");
		pv.appendChild(innerDocument.createTextNode(data));
	pi.appendChild(pv);	
	pi.appendChild(innerDocument.createTextNode("?>"));
	return pi;
}
function createViewDocType(name, publicId, systemId, internalSubset) {
	var dt = innerDocument.createElementNS(XUL,"dt");
	var id = "DOCTYPE";
	dt.setAttribute("id", id);
	dt.appendChild(innerDocument.createTextNode("<!DOCTYPE "));
	var en = innerDocument.createElementNS(XUL, "en");
		en.setAttribute("onkeypress", "expandAttributes(event, id)");
		en.appendChild(innerDocument.createTextNode(name));
	dt.appendChild(en);
	var ats = innerDocument.createElementNS(XHTML, "ats"); // Container for attributes
	ats.setAttribute("id", "DOCTYPEA");
	dt.appendChild(ats);
	if (publicId) {
		var vattr = createViewAttribute("PUBLIC", publicId, false);
		ats.appendChild(vattr);
		vattr = createViewAttribute("SYSTEM", systemId, false);
		ats.appendChild(vattr);
	}
	else
		if (systemId) {
			vattr = createViewAttribute("SYSTEM", systemId, false);
			ats.appendChild(vattr);
		}	
	var dtx = innerDocument.createElementNS(XUL, "dtx");
	var dtxs = innerDocument.createElementNS(XUL, "dtxs");
		dtxs.appendChild(innerDocument.createTextNode(" ["));
	dtx.appendChild(dtxs);	
	var isData;
	if (internalSubset) {
		if (internalSubset.substr(0,1) == "[") // in DOM3 the [ will disappear.
			isData = internalSubset.substr(1, internalSubset.length-2);
		else
			isData = internalSubset;
	}
	else isData = "";
	var tx = createViewText(isData);
	dtx.appendChild(tx);
	var dtxe = innerDocument.createElementNS(XUL, "dtxe");
	dtxe.appendChild(innerDocument.createTextNode("]"));
	dtx.appendChild(dtxe);
	dt.appendChild(dtx);

	var ele = innerDocument.createElementNS(XUL,"ele");
	ele.appendChild(innerDocument.createTextNode(">"));
	dt.appendChild(ele);
	return dt;	
}


function getNextId() {
	lastNodeIndex++;
	return "N" + lastNodeIndex;
}

function buildViewAttributes(el, node) {
	var attrs = node.attributes;
	for (var i=0; i<attrs.length; i++) {
		var attr = attrs.item(i);
		var vattr = createViewAttribute(attr.name, attr.value, true)		
		insertViewAttribute(el, vattr, null);
	}
}
function getElementContainer(el) {
	if (el.localName != "el") // top level.
		return el;
	if (el.lastChild.nodeName == "et")
		return el.lastChild.previousSibling;
	else	
		return makeElementContainer(el);	
}

function makeElementContainer(el) {
	// not a container - make it one.	
	var cid = el.getAttribute("id");
	var pl = document.createElementNS(XUL, "image");
		pl.setAttribute("onclick", "expand(event, '" + cid + "')");
		pl.setAttribute("class","twisty");
		pl.setAttribute("align","baseline");
		if (currentLevel != expandLevel) 
			pl.setAttribute("open", true);
	el.insertBefore(pl, el.firstChild);
	var container = innerDocument.createElementNS(XHTML,"exp");
	//? Exp element has same id as element but with X suffix.
	//?container.setAttribute("id", cid + "X");
	if (currentLevel == expandLevel) 
		container.setAttribute("style", "display:none");
	else 
		container.setAttribute("style", "display:block");
	insertDDMarker(container);
	el.lastChild.firstChild.nodeValue = ">";
	el.appendChild(container);
	var et = innerDocument.createElementNS(XHTML,"et");
	et.appendChild(innerDocument.createTextNode("</"));
	var etn = innerDocument.createElementNS(XUL, "etn");
		etn.appendChild(innerDocument.createTextNode(getEnFromEl(el).firstChild.nodeValue));
	et.appendChild(etn);	
	et.appendChild(innerDocument.createTextNode(">"));
	if (currentLevel == expandLevel) 
		et.setAttribute("style", "display:none");
	else 
		et.setAttribute("style", "display:block");
	el.appendChild(et);
	return container;
}
// Insert view attribute into view element before refAttr (null = append).
function insertViewAttribute(el, vattr, refVattr) {
	var ats = getAtsFromEl(el);
	ats.insertBefore(vattr, refVattr);
}

function removeViewAttribute(vattr) {
	vattr.parentNode.removeChild(vattr);
}

// Insert view element into view element  before refEl (null = append).
function insertViewElement(parentEl, newEl, refEl) {
	var container = getElementContainer(parentEl);
	container.insertBefore(newEl, refEl);
	var dd = innerDocument.createElementNS(XHTML, "hr");
	container.insertBefore(dd, refEl);
	
}
function removeViewElement(el) {
	var container = el.parentNode;
	if (el.nextSibling.nodeName == "hr")
		container.removeChild(el.nextSibling);
	container.removeChild(el);
	// If no longer a container the convert to empty element.
	if (container.localName == "exp" && isContainerEmpty(container)) {
		if (container.firstChild)
			container.removeChild(container.firstChild); // The hr
		var parentEl = container.parentNode;
		parentEl.removeChild(container.nextSibling); // end tag
		parentEl.removeChild(container); // exp
		parentEl.removeChild(parentEl.firstChild); // twisty
		parentEl.lastChild.firstChild.nodeValue = "/>";
	}
}
function isContainerEmpty(container) {
	var viewNode = container.firstChild;
	if (viewNode) {
		if (viewNode.nodeName != "hr") 
			return false;
		else
			return (!(viewNode.nextSibling)); // something else in container (may be another hr)		
	}
	else 
		return true;
}
function reNumber(viewNode) {
	switch (viewNode.nodeName) {
	case "el":
		var newId = getNextId();
		var ats = getAtsFromEl(viewNode);
		ats.setAttribute("id",newId + "A");
		var exp = getExpFromEl(viewNode);
		if (exp)
			exp.setAttribute("id",newId + "X");
		// Leave untill last so that getxxxFromEl with old id still works				
		viewNode.setAttribute("id", newId); 
		break;
	case "cm":	
	case "pi":	
		viewNode.setAttribute("id",getNextId());
		break;
	}	
}
function insertDDMarker(viewNode) {
	var dd = innerDocument.createElementNS(XHTML, "hr");
	viewNode.appendChild(dd);
}

function getContainerType(node) {
	var containerType = CTR_EMPTY;
	node = node.firstChild;
	while (node) {
		switch (node.nodeType) {
			case NODE_TYPE_ELEMENT:
				containerType |= CTR_BLOCK;
				break;
			case NODE_TYPE_TEXT:	
				var isWS = RE_Whitespace.test(node.nodeValue);
				if (!isWS)			
					containerType |= CTR_INLINE;
				break;
			case NODE_TYPE_CDATA:	
				containerType |= CTR_BLOCK;
				break;
			case NODE_TYPE_COMMENT:	
				return CTR_BLOCK;
			default:
				return CTR_BLOCK;
		}			
		if (containerType >= CTR_BLOCK)
			return CTR_MIXED;
		node = node.nextSibling;
	}
	return containerType;
}

function createViewAttribute(attrName, attrValue, equalsRequired) {
	var at = atTemplate.cloneNode(true);
	var an = getAnFromAt(at);
	an.firstChild.nodeValue = attrName;
	getAvFromAt(at).firstChild.nodeValue = attrValue;
	if (!equalsRequired) {
		an.nextSibling.nodeValue = " ";
	}
	return at;
}
function makeAttributeTemplate() {
	// if you change the order of nodes here then change createViewAttribute.
	var at = innerDocument.createElementNS(XUL,"at");
			at.appendChild(innerDocument.createTextNode("\n\t")); // inter-attribute spacer
			var an = innerDocument.createElementNS(XUL, "an");
				an.appendChild(innerDocument.createTextNode("theName"));
		at.appendChild(an);
		at.appendChild(innerDocument.createTextNode("="));
			var qt = innerDocument.createElementNS(XUL,"qts");
				qt.appendChild(innerDocument.createTextNode("\""));
		at.appendChild(qt);	
			var av = innerDocument.createElementNS(XUL, "av");
				av.appendChild(innerDocument.createTextNode("theValue"));
		at.appendChild(av);
				qt = innerDocument.createElementNS(XUL,"qte");
				qt.appendChild(innerDocument.createTextNode("\""));
		at.appendChild(qt);
	return at;
}
//=========================================================================
// Utility functions to navigate arround view nodes.
function getPnFromPi(pi) {
	return pi.firstChild.nextSibling;
}
function getAnFromAt(at) {
	return at.firstChild.nextSibling;
}
function getAvFromAt(at) {
	return at.lastChild.previousSibling;
}
function getAtFromAn(an) {
	if (an.nodeName == "at")
		return an;
	else	
		return an.parentNode;	
}
function getAtFromAv(av) {
	return av.parentNode;	
}
function getElFromEn(en) {
	return en.parentNode;
}
function getCdxFromCd(cd) {
	return cd.firstChild.nextSibling;
}
function getCxFromCm(cm) {
	return cm.firstChild.nextSibling.nextSibling;
}
function getEnFromEl(el) {
	var en = el.firstChild.nextSibling;
	if (en.nodeName == "en")
		return en;
	else
		return en.nextSibling; // allow for twisty.
}
function getElFromViewNode(viewNode) {
	switch (viewNode.localName) {
	case "an":
	case "av":
		return viewNode.parentNode.parentNode.parentNode; //vn->at->ats->el
	case "el":	
	case "cm":	
	case "tx":	
	case "cd":	
	case "pi":	
	case "dt":	
	case "xml":	
		return viewNode;	// vn is it!
	case "etn":	
		return viewNode.parentNode.parentNode;
	default:
		return viewNode.parentNode;
	}	
}
function getParentFromViewNode(viewNode) {
	if (viewNode.parentNode.nodeName == "exp") 
		return viewNode.parentNode.parentNode;
	else	
		return viewNode.parentNode;
}

function getAtsFromEl(el) {
	var ats = el.firstChild.nextSibling.nextSibling;
	if (ats.nodeName == "ats")
		return ats;
	else
		return ats.nextSibling; // allow for twisty.
}
function getAtFromAts(ats, name) {
	var at = ats.firstChild;
	while (at) {
		if (at.localName == "at") {
			var an = getAnFromAt(at);
			if (an.firstChild.nodeValue == name)
				return at;
		}
		at = at.nextSibling;
	}
	return null;
}
// This could return null if not a container.
function getExpFromEl(el) {
	if (el.firstChild.nodeName == "#text") // Not a container.
		return null;
	else	
		return el.lastChild.previousSibling;
}
// Get focusable node from within major element.
function getFocusFromViewNode(viewNode) {
	if (!viewNode)
		return null;
	switch (viewNode.nodeName) {
		case "el":
			return getEnFromEl(viewNode);
		case "pi":
			return getPnFromPi(viewNode);
		case "cd":
			return getCdxFromCd(viewNode);
		case "cm":
			return getCxFromCm(viewNode);
		default:
			return viewNode;
	}
}
// invoke with prefix = null.
function getElNamespaceURI(el, prefix) {
	if (!el)
		return "";
	if (prefix == null || prefix == undefined)
		prefix = getElPrefix(el);
		
	var ats = getAtsFromEl(el);
	var nsAttr = "xmlns";
	if (prefix)
		nsAttr += ":" + prefix;
	var at = getAtFromAts(ats, nsAttr);
	// if ns defined here then return it.
	if (at) 
		return getAvFromAt(at).firstChild.nodeValue || "";
	// OK now check parents.
	if (el.getAttribute("id") != "DOCELEM") {
		el = el.parentNode.parentNode; // exp->el;
		return getElNamespaceURI(el, prefix); 
	}
	else
		return ""; // really unknown.
}
function getElPrefix(el) {
	if (!el)
		return "";
	var en = getEnFromEl(el);	
	if (!en)
		return "";
	var elName = en.firstChild.nodeValue;
	var i = elName.indexOf(":");
	if (i == -1)
		return "";
	else
		return elName.substr(0,i);
}
function getElLocalName(el) {
	if (!el)
		return null;
	var en = getEnFromEl(el);	
	if (!en)
		return null;
	var elName = en.firstChild.nodeValue;
	var i = elName.indexOf(":");
	if (i == -1)
		return elName;
	else
		return elName.substr(i+1);
}
function getDtFromEl(el) {
}

//==========================================================================================
function cmdSave() {
	OnSave();
}

function cmdSaveAs() {
	OnSaveAs();
}

function cmdClose() {
	if (OnClose())
		close();
}

function cmdUndo() {
	innerWindow.cmdUndo();
}

function cmdRedo() {
	innerWindow.cmdRedo();
}

function cmdInsertComment(insertInto) {
	innerWindow.cmdInsertComment(insertInto);
}

function cmdInsertPI() {
	innerWindow.cmdInertPI();	
}

function cmdInsertElement(insertInto) {
	innerWindow.cmdInsertElement(insertInto);
}

function cmdInsertAttribute() {
	innerWindow.cmdInsertAttribute();
}

function cmdInsertText(insertInto) {
	innerWindow.cmdInsertText(insertInto);
}

function cmdInsertCDATA(insertInto) {
	innerWindow.cmdInsertCDATA(insertInto);
}

function cmdValidate() {
	setViewDerivs(); //FIXME this does not get loaded in OnLoad.
	var viewDocElement = xmlBrowser.contentDocument.getElementById("DOCELEM");
	var namespaceURI = getElNamespaceURI(viewDocElement);
	var schema;
	if (!namespaceURI) {
		var ats = xmlBrowser.contentDocument.getElementById("DOCTYPEA");
		var publicId = null;
		if (ats) {
			var at = getAtFromAts(ats, "PUBLIC");
			if (at)
				publicId = getAvFromAt(at).firstChild.nodeValue;
		}
		if (!publicId) {
			alert("No schema could be found for this document type.");
			return;
		}
		schema = xulapp.schemas.getSchemaByPublicId(publicId);
	}
	else
		schema = xulapp.schemas.getSchemaByNamespaceURI(namespaceURI);
		
	var errorList = new ErrorList();
	if (validateViewDocument(schema, viewDocElement, errorList)) 
		text = "Valid document.";
	else
		text = "Errors found:\n";
	for (var i=0; i<errorList.errors.length; i++) {
		text+= errorList.errors[i].msg + "\n";
	}
	alert(text);
	
}
function validateViewDocument(schema, viewDocElement, errorList) {
	return (EmptySequence == schema.grammar.start.viewDeriv(viewDocElement, null, errorList));
}

function ErrorList() {
	this.errors = [];
}
ErrorList.prototype.log = function(node, msg) {
	var err = {node: node, msg: msg };
	this.errors.push(err);
}
ErrorList.prototype.clear = function() {
	this.errors = [];
}

function cmdValidateNav(next) {
}


function onTransaction(transactionManager) {
	// Enable/Disable Undo/Redo commands
	var canUndo = (transactionManager.numberOfUndoItems > 0);
	var canRedo = (transactionManager.numberOfRedoItems > 0);

	var cmdSave = document.getElementById("cmdSave");
	cmdSave.setAttribute("disabled", !canUndo);
	var cmdUndo = document.getElementById("cmdUndo");
	cmdUndo.setAttribute("disabled", !canUndo);
	var cmdRedo = document.getElementById("cmdRedo");
	cmdRedo.setAttribute("disabled", !canRedo);
	openTool.isModified = canUndo;
	setTitle();
}
//==========================================================================================
function DomFromDomView() {
	var body = xmlBrowser.contentDocument.getElementById("body");
	var xmlDoc = document.implementation.createDocument(XHTML, "", null);
	buildDom(xmlDoc, body.firstChild, xmlDoc);
	return xmlDoc;
}
function buildDom(xmlDoc, viewNode, node) {
	while (viewNode) {
		switch (viewNode.localName) {
		case "hr": // These are between nearly every line;
			break;
		case "el": // ELEMENT
			var en = getEnFromEl(viewNode).firstChild.nodeValue;
			var el = xmlDoc.createElementNS(XHTML, en);
			var ats = getAtsFromEl(viewNode);
			var at = ats.firstChild;
			while (at) {
				var an = getAnFromAt(at).firstChild.nodeValue;
				var av = getAvFromAt(at).firstChild.nodeValue;
				el.setAttribute(an, av);
				at = at.nextSibling;
			}
			var exp = getExpFromEl(viewNode);
			if (exp && exp.firstChild) 
		 		buildDom(xmlDoc, exp.firstChild, el);
			node.appendChild(el);
			break;
		case "tx": // PCDATA
			var data = viewNode.firstChild.nodeValue;
			var tx = xmlDoc.createTextNode(data);
			node.appendChild(tx);
			break;
		case "cd": // CDTATA
			data = getCdxFromCd(viewNode).firstChild.nodeValue;
			var cd = xmlDoc.createCDATASection(data);
			node.appendChild(cd);
			break;
		case "cm": // COMMENT
			data = getCxFromCm(viewNode).firstChild.nodeValue;
			var cm = xmlDoc.createComment(data);
			node.appendChild(cm);
			break;
		case "pi": // PROCESSING INSTRUCTION
			var target = viewNode.firstChild.nextSibling.firstChild.nodeValue;
			data = viewNode.lastChild.previousSibling.firstChild.nodeValue;
			var pi = xmlDoc.createProcessingInstruction(target, data);
			node.appendChild(pi);
			break;
		case "dt": // DOCTYPE
			// internal subset?
			if (viewNode.lastChild.previousSibling.localName == "dtx") {
				var dtx = viewNode.lastChild.previousSibling;
				var isData = dtx.firstChild.nextSibling.firstChild.nodeValue;
				if (isData) {
					isData = "[" + isData + "]";
					// The dipsticks at W3C allow you to read the internal subset but not to write it.
					// So write a PI which we can pickup when we serialize the DOM.
					var is = xmlDoc.createProcessingInstruction("xulapp-internalsubset",isData);
					node.appendChild(is);
				}
			}
			var name = getEnFromEl(viewNode).firstChild.nodeValue;
			var publicId = null;
			var systemId = null;
			ats = getAtsFromEl(viewNode);
			at = getAtFromAts(ats, "SYSTEM");
			if (at)
				systemId = getAvFromAt(at).firstChild.nodeValue;
			at = getAtFromAts(ats, "PUBLIC");
			if (at)
				publicId = getAvFromAt(at).firstChild.nodeValue;
			var dt = xmlDoc.implementation.createDocumentType(name, publicId, systemId);
			node.appendChild(dt);
			break;
		case "xml":
			break; // nothing we can do here until DOM3
		default:
		}
		viewNode = viewNode.nextSibling;
	}	
}

