/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is XulApp IDE.
 *
 * The Initial Developer of the Original Code is Synesis Software (USA) Inc.
 *

 * Portions created by the Initial Developer are Copyright (C) 2001-2005
 * Synesis Software (USA) Inc. the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * 	Peter Wilson, orignal author.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the LGPL or the GPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 *
 * ***** END LICENSE BLOCK ***** */
 
 
netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");

var xulapp = window.arguments[0];

var theSrcNode;
var theNodeId;
var regexpStruct = new Object();

function OnLoad(event) {
	if (xulapp.currentDocument) {
		// ensure the currently selected widget is displayed.
		var openDoc = xulapp.currentDocument;
		if (openDoc.selectedNodeIds.length == 1) 
			OnWidgetSelected(openDoc.selectedNodeIds[0], true);
		else {
				theSrcNode = null;
				theNodeId = null;
				clearProperties();
		}

	}
}

function OnWidgetSelected(nodeId, isSelected) {
	//debug("PI OWS:" + srcNode.localName + ":" + isSelected);
	if (isSelected) {
		if (nodeId == theNodeId)
			return;
		theNodeId = nodeId;	
		theSrcNode = xulapp.currentDocument.getIdMapNode(nodeId);		
		clearProperties();
		if (theSrcNode)
			loadProperties();
	}		
	else {	
		theSrcNode = null;
		theNodeId = null;
		clearProperties();
	}		
}

function clearProperties() {
	// clear old widget attributes.
	var listBox = document.getElementById("propertiesList");
	//Warn listbox.removeItemAt is currently broken. 
	listItems = listBox.getElementsByTagName("listitem");
	while (listBox.getRowCount() > 0) {
		listBox.removeChild(listItems.item(0)); 
	}
}

function loadProperties() {
	if (!theSrcNode) return;
	var deck = document.getElementById("theDeck");
	switch (theSrcNode.nodeType) {
	case NODE_TYPE_COMMENT:
		deck.selectedIndex = 1;
		var textbox = document.getElementById("theComment");
		textbox.setAttribute("value", theSrcNode.data);
		break;
	case NODE_TYPE_PROCESSING_INSTRUCTION:
		deck.selectedIndex = 2;
		var thePICaption = document.getElementById("thePICaption");
		thePICaption.setAttribute("value", "Processing instruction: " + theSrcNode.target);
		textbox = document.getElementById("theData");
		textbox.setAttribute("value", theSrcNode.data);
		// XXX break attr=name pairs down and use regular attributes types.
		break;
	case NODE_TYPE_DOCUMENT_TYPE:
		deck.selectedIndex = 3;
		var theDOCTYPECaption = document.getElementById("theDOCTYPECaption");
		theDOCTYPECaption.setAttribute("value", "Document Type: " + theSrcNode.name);
		textbox = document.getElementById("theData");
		textbox.setAttribute("value", theSrcNode.systemId);
		// XXX break attr=name pairs down and use regular attributes types.
		break;
	case NODE_TYPE_ELEMENT:
		deck.selectedIndex = 0;
		if (theSrcNode.hasAttributes()) {
			var listBox = document.getElementById("propertiesList");
			// if id attribute exists - put it first.
			var idAttr = theSrcNode.getAttributeNode("id");
			if (idAttr != null) {
				listBox.appendChild(buildItem(idAttr.name, idAttr.value));			
			}
			var attrs = theSrcNode.attributes;
			for (var i=0; i<attrs.length; i++) {
				if (attrs.item(i).name != "id") {
					var attr = attrs.item(i);
					listBox.appendChild(buildItem(attr.name, attr.value));
				}	
			}
		}
		break;
	default:
		return;
	}
	
}

function buildItem(attributeid, attrValue) {
	var attributeDef = getAttributeDef(theSrcNode.localName, attributeid);

	var listItem = document.createElement("listitem");
	listItem.attributeid = attributeid; // cache for attribute removal.				
	listItem.setAttribute("allowevents","true"); // otherwise included widgets will be UI dead.

	listCell = document.createElement("listcell");
			listCell.setAttribute("label", attributeid);
			listCell.setAttribute("flex","1");
			listItem.appendChild(listCell);
	listCell = document.createElement("listcell");
			listCell.setAttribute("allowevents","true"); // otherwise included widgets will be UI dead.
			listCell.setAttribute("flex","1");
			var attributeType = "custom";
			if (attributeDef) {
				attributeType = attributeDef.getAttribute("type");
				if (!attributeType) attributeType = "string";
			}	
			switch (attributeType) {
			case "boolean":
				var checkbox = document.createElement("checkbox");
				checkbox.setAttribute("checked", attrValue); 
				checkbox.setAttribute("oncommand", "checkboxPropertyChanged(event);");
 				checkbox.attributeid = attributeid; // cache				
				listCell.appendChild(checkbox);
				break;
			case "list":	
				var menulist = document.createElement("menulist");
				menulist.setAttribute("label", attrValue);
				menulist.setAttribute("flex", "1");				
				menulist.setAttribute("oncommand", "menulistPropertyChanged(event);");
				var menupopup = document.createElement("menupopup");
 				menupopup.setAttribute("onpopupshowing", "buildAttributeValuesPopup(event)");
 				menupopup.attributeid = attributeid; // cache
				menulist.appendChild(menupopup);
				listCell.appendChild(menulist);
				break;
			default:	
				var textbox = document.createElement("textbox");
				textbox.setAttribute("value", attrValue);
				textbox.setAttribute("onblur", "textPropertyBlur(event);");
				textbox.setAttribute("flex","1");
				textbox.attributeid = attributeid; // cache
				listCell.appendChild(textbox);
			}	
	listItem.appendChild(listCell);

	return listItem;
}

function checkboxPropertyChanged(event) {
	var checkbox = event.target;
	if (checkbox.localName != "checkbox")
		return;
	var value = (checkbox.getAttribute("checked")=="true") ? "true" : "false";
	updateAttribute(checkbox.attributeid, value);
}

function menulistPropertyChanged(event) {
	var menuitem = event.target;
	if (menuitem.localName != "menuitem")
		return;
	var menupopup = menuitem.parentNode; // menuitem->menupopup.
	if (menupopup.localName != "menupopup")
		return;

	updateAttribute(menupopup.attributeid, menuitem.getAttribute("label"));
}

function commentBlur(event) {
	var inputElement = event.target; // an html:input object.
	var oldValue = theSrcNode.data;
	if (oldValue != inputElement.value) {
		theSrcNode.data = inputElement.value;
		xulapp.currentDocument.notifyAttributeChanged(theSrcNode, null, oldValue, theSrcNode.data, window);
	}	
}


function PIPropertyBlur(event) {
	var inputElement = event.target; // an html:input object.
	var oldValue = theSrcNode.data;
	if (oldValue != inputElement.value) {
		theSrcNode.data = inputElement.value;
		xulapp.currentDocument.notifyAttributeChanged(theSrcNode, null, oldValue, theSrcNode.data, window);
	}	
}
function DOCTYPEPropertyBlur(event) {
	var inputElement = event.target; // an html:input object.
	var oldValue = theSrcNode.systemId;
	if (oldValue != inputElement.value) {
		var systemId = (inputElement.value)?inputElement.value:""; 
		var docType = document.implementation.createDocumentType("window","",systemId);
		var dom = theSrcNode.ownerDocument;
		dom.replaceChild(docType, theSrcNode);
		xulapp.currentDocument.notifyAttributeChanged(theSrcNode, null, oldValue, docType.systemId, window);
	}	
}

function textPropertyBlur(event) {
	var inputElement = event.target; // an html:input object.
	// find owning textbox:
	var textbox = inputElement; // start here just in case this changes in the future.
	while (textbox.localName != "textbox") {
		textbox = textbox.parentNode;
		if (!textbox) break; // no textbox parent!
	}
	if (!textbox) return;

	// Apply RegExp to check value.
	getAttributeRegexp(textbox.attributeid, regexpStruct);
	if (regexpStruct.regexp) {
		//debug("regexp:" + regexpStruct.regexp);
		if (!regexpStruct.regexp.test(inputElement.value)) {		
			alert("Attribute:" + textbox.attributeid + " value:" + inputElement.value + "\n" + regexpStruct.errmsg);
			textbox.focus();
			event.cancelBubble;
			return;
		}
	}
	// XXX we should prevent empty string.

	updateAttribute(textbox.attributeid, inputElement.value);
}

function updateAttribute(attributeid, newValue) {
	var oldValue = theSrcNode.getAttribute(attributeid);

	// only change attribute if value has changed = minimize DOM mutation events.
	if (oldValue != newValue) {
		//debug(attributeid + " Old:" + oldValue + " New:" + newValue);
		theSrcNode.setAttribute(attributeid, newValue);
		xulapp.currentDocument.notifyAttributeChanged(theNodeId, attributeid, oldValue, newValue, window);		
	}

}

function rmvAttribute(event) {
	var listbox = event.target;
	if (listbox.localName != "listbox")
		return;
	var selectedItems = listbox.selectedItems;
	for (var i=0; i<selectedItems.length; i++) {
		var listitem = selectedItems[0];

		var attributeid = listitem.attributeid;
		var oldValue = theSrcNode.getAttribute(attributeid);
		theSrcNode.removeAttribute(attributeid);
		xulapp.currentDocument.notifyAttributeChanged(theNodeId, attributeid, oldValue, null, window);
		listbox.removeChild(listitem);
	}
}

function getAttributeRegexp(attributeid, regexpStruct) {
	var regexp = null
	regexpStruct.regexp = null;
	regexpStruct.errmsg = null;
	var attributeDef = getAttributeDef(theSrcNode.localName, attributeid);
	if (!attributeDef) {
		alert("Atrribute definintion:" + attributeid + "not found.");
		return;
	}
	var attributeTypeName = attributeDef.getAttribute("type");
	if (!attributeTypeName) attributeTypeName = "string"; // the default
	var attributeType = xulapp.attributeTypes.getElementById(attributeTypeName);
	if (!attributeType)
		return;
	var regexp = attributeType.getAttribute("regexp")
	regexpStruct.errmsg = attributeType.getAttribute("errmsg")
	// parse and convert regexp to compiled re
	if (regexp) {
		var i = regexp.lastIndexOf("/");
		var re = regexp.substring(1,i); // drop "/" off pattern
		if (i == (regexp.length -1)) {
			regexpStruct.regexp = new RegExp(re);
		}
		else {
			var flags = regexp.substr(i+1);		
			regexpStruct.regexp = new RegExp(re, flags);
		}
	}
}

function buildAttributesPopup(event, loadEventHandlers) {
	if (!theSrcNode)
		return false; // no popup.
	var attributesets = xulapp.widgets.getElementsByTagName("attributeset");
		
	var menupopup = event.target;
	// clear popup.
	while (menupopup.hasChildNodes()) {
		menupopup.removeChild(menupopup.firstChild);
	}
	
	var widgetDef = xulapp.widgets.getElementById(theSrcNode.localName);
	if (!widgetDef) {
		alert("Widget definition for:" + theSrcNode.localName + " not found.");
		return false;
	}	

	// get widgets attributes element
	var attributes = widgetDef.getElementsByTagName("attributes");
	if (attributes.length <= 0)
		return false;
	for (var i=0; i< attributes.length; i++) {
		// load references attribute set.
		var attributesetId = attributes.item(i).getAttribute("attributeset");
		if (attributesetId) {
			var attributeset = getAttributeset(attributesets, attributesetId);
			if (!attributeset) {
				debug ("Attributeset:" + attributesetId + " not found.");
				continue;
			}
			refAttributes =	attributeset.getElementsByTagName("attribute");
			buildAttributeMenuItem(menupopup, refAttributes, loadEventHandlers);
			var menuseparator = document.createElement("menuseparator");
			menupopup.appendChild(menuseparator);
		}
		var widgetAttributes = widgetDef.getElementsByTagName("attribute");
		buildAttributeMenuItem(menupopup, widgetAttributes, loadEventHandlers );
	}
	return true;
}
function getAttributeset(attributesets, attributesetId) {
	for (var i=0; i<attributesets.length; i++) {
		var attributeset = attributesets.item(i);
		if (attributeset.getAttribute("setid") == attributesetId)
			return attributeset;
	}
	return null;
}


function buildAttributeMenuItem(menupopup, attributesNodeList, loadEventHandlers) {
	for (var i=0; i<attributesNodeList.length; i++) {	
		var attributeRef = attributesNodeList.item(i);
		var attributeid = attributeRef.getAttribute("attributeid");
		var attributeDef = getAttributeDef(theSrcNode.localName, attributeid);
		if (attributeDef) {
			var menuitem = document.createElement("menuitem");
			if (attributeDef.hasAttribute("eventhandler")) {
				if (!loadEventHandlers) continue;
			}
			else {
				if (loadEventHandlers) continue;		
			}
			menuitem.attributeid = attributeid;	// cache	
			menuitem.setAttribute("label", attributeid);
			menupopup.appendChild(menuitem);
		}	
	}	
}
function buildAttributeValuesPopup(event) {
	if (!theSrcNode) 
		return false; // no popup.
	var menupopup = event.target;
	if (menupopup.localName != "menupopup")
		return;
	// clear popup.
	while (menupopup.hasChildNodes()) {
		menupopup.removeChild(menupopup.firstChild);
	}

	var attributeDef = getAttributeDef(theSrcNode.localName, menupopup.attributeid);
	var values = attributeDef.getAttribute("values");
	if (!values) 
		return false;

	var v = values.split(/\s+/);
	for (var i=0; i<v.length; i++) {
		var menuitem = document.createElement("menuitem");
		menuitem.setAttribute("label", v[i]);
		menupopup.appendChild(menuitem);
	}	
	return true; // show popup.
}

function addSelectedAttribute(event) {
	if (!theSrcNode)
		return;
	var menuItem = event.target;
	if (menuItem.localName != "menuitem" )
		return;
	var attributeid = menuItem.attributeid;
	if (!theSrcNode.getAttribute(attributeid)) {
		var listBox = document.getElementById("propertiesList");
		var attributeDef = getAttributeDef(theSrcNode.localName, attributeid);
		var values = attributeDef.getAttribute("values");
		value = ""
		if (values) {
			var v = values.split(/\s/);
			if (v.length > 0)
				value = v[0];
		}
		var listItem = buildItem(attributeid,value);
		listBox.appendChild(listItem);	
		
		// For some attribute types we need to set the attribute value using the default value.
		// For these types the user may not change the value before leaving the widget and would expect
		// the displayed value to be reflected in the displayed form.
		attributeType = attributeDef.getAttribute("type");
		if (attributeType) attributeType != "string";
		switch (attributeType) {
		case "boolean":
			updateAttribute(attributeid, "false");
			break;
		case "list":
			updateAttribute(attributeid, value);
			break;
		default:
		}
	}
	selectAttribute(attributeid)

}

function findItem(attributeid) {
	var listBox = document.getElementById("propertiesList");
	for (var i=0; i<listBox.getRowCount(); i++) {
		var listItem = listBox.getItemAtIndex(i);
		if (listItem.attributeid == attributeid)
			return listItem;
	}
	return null;
}

// show attribute as selected in properties list.
function selectAttribute(attributeid) {
	var listItem = findItem(attributeid);
	if (listItem) {
		listBox.selectItem(listItem);
		listBox.ensureElementIsVisible(listItem);
	}
}

function getAttributeDef(localName, attributeid) {
	var attributeDef = xulapp.widgetAttributes.getElementById(attributeid);
	if (!attributeDef) {
		alert("Attribute definition not found for widgetid:" + localName + " attributeid:" + attributeid);
		return null;
	}
	if (attributeDef.hasChildNodes()) {
		var childNodes = attributeDef.getElementsByTagName("subattribute");
		for (var i=0; i<childNodes.length; i++) {
			attributeDef = childNodes[i];
			if (attributeDef.getAttribute("widget") == localName)
				return attributeDef;
		}
		alert("Attribute definition not found for widgetid:" + localName + " attributeid:" + attributeid);
		return null;
		}
	else
		return attributeDef;
}

// Build list of items currently selected.


function OnUnload(event) {
	if (xulapp.widgetTreeEditor) {
		xulapp.widgetTreeEditor.btnShowPropertyInspector.removeAttribute("checked");
		xulapp.widgetTreeEditor.propInspector = null;
	}
	
}
