/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is XulApp IDE.
 *
 * The Initial Developer of the Original Code is Synesis Software (USA) Inc.
 *

 * Portions created by the Initial Developer are Copyright (C) 2001-2005
 * Synesis Software (USA) Inc. the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * 	Peter Wilson, orignal author.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the LGPL or the GPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 *
 * ***** END LICENSE BLOCK ***** */
 
netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");

var xulapp = window.arguments[0];

	buildToolbox();
	
const MIMETYPE_NEW_WIDGET = "text/x-xulapp-newwidget";
	

function OnLoad() {
	window.sizeToContent();
}

var widgetbarObserver = { 
  onDragStart: function (evt,transferData,action){
    var txt=evt.target.getAttribute("widgetid");
    xulapp.dropdata = txt;
    transferData.data=new TransferData();
    transferData.data.addDataForFlavour(MIMETYPE_NEW_WIDGET,txt);
  }
};

function buildToolbox() {
	var toolbox = document.createElement("toolbox");
	toolbox.setAttribute("id","toolbox");
	toolbox.setAttribute("flex","1");

	var toolbarDefs = xulapp.toolbars.getElementsByTagName("toolbar");
	for (var i=0; i<toolbarDefs.length; i++) {
		var toolbarDef = toolbarDefs.item(i);
		var toolbar = document.createElement("toolbar");
		toolbar.setAttribute("id",toolbarDef.getAttribute("id"));
		toolbar.setAttribute("grippytooltip","aTooltip");
		toolbar.setAttribute("grippytooltiptext",toolbarDef.getAttribute("tooltiptext"));
		toolbar.setAttribute("flex","1");

		buildToolbar(toolbar, toolbarDef);
		toolbox.appendChild(toolbar);
	}

	var win = document.getElementById("widgetbar");
	win.appendChild(toolbox);
	window.sizeToContent();
}
/** Build images in widget bar
**/
function buildToolbar(toolbar, toolbarDef) {
	var toolbarIdPrefix = toolbar.getAttribute("id") + "-";
	
	var widgets = toolbarDef.getElementsByTagName("widget");
	for (var i=0; i < widgets.length; i++) {
		var widget = widgets.item(i);
		// WARNING: eplace with toolbarbutton when available
		var button = document.createElement("toolbarbutton");
		button.setAttribute("id",toolbarIdPrefix + widget.getAttribute("id"));
		//button.setAttribute("class","toolbarbutton-1");
		button.setAttribute("ondraggesture","nsDragAndDrop.startDrag(event,widgetbarObserver);");
		button.setAttribute("widgetid",widget.getAttribute("widgetid"));
		var image = "chrome://xulapp/content/image/widgetIcons/" + widget.getAttribute("largeicon")
		button.setAttribute("image",image);
		button.setAttribute("tooltip","aTooltip"); // standard Mozilla tooltip popup.
		button.setAttribute("tooltiptext",widget.getAttribute("tooltiptext"));
		toolbar.appendChild(button);
	}
	var spacer = document.createElement("spacer")
	spacer.setAttribute("flex","1");
	toolbar.appendChild(spacer);

}

function OnUnload() {
	
	if (xulapp.widgetTreeEditor) {
		xulapp.widgetTreeEditor.btnShowToolbox.removeAttribute("checked");
		xulapp.widgetTreeEditor.widgetbar = null;
	}
}
