/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is XulApp IDE.
 *
 * The Initial Developer of the Original Code is Synesis Software (USA) Inc.
 *

 * Portions created by the Initial Developer are Copyright (C) 2001-2005
 * Synesis Software (USA) Inc. the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * 	Peter Wilson, orignal author.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the LGPL or the GPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 *
 * ***** END LICENSE BLOCK ***** */
 
netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");

const XULNS="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul"

var xulapp = window.arguments[0];
var openTool = window.arguments[1];
var xulDoc = null;
var srcDOM = null;
//var xulEditorWindowLauncher = window.arguments[2];

var ignoreTags = new Object();
ignoreTags["script"] = true;
ignoreTags["broadcasterset"] = true;
ignoreTags["broadcaster"] = true;
ignoreTags["keyset"] = true;
ignoreTags["key"] = true;
ignoreTags["stringbundleset"] = true;
ignoreTags["stringbundle"] = true;
ignoreTags["commandset"] = true;
ignoreTags["command"] = true;



// fields used for selection processing
var theWindow = null;
var theBulletinboard = null;
var theSelector = null;

// stylesheets used by xulEditor;
var knownStyleSheets = [];

function OnLoad(event) {
	//debug("LOAD");
	openTool.xulDoc = xulapp.openDocuments.findDocumentByPath(openTool.fileURI);
	if (openTool.xulDoc == null) {
		openTool.xulDoc = xulapp.openDocuments.createDocument(openTool.fileURI, ".xul", true);
		openTool.xulDoc.srcDOM = openTool.xulDoc.loadDOM();
		openTool.xulDoc.buildIdMap();
	}
	xulapp.currentDocument = openTool.xulDoc;
	openTool.xulDoc.registerSelectionListener(OnWidgetSelected);
	openTool.xulDoc.registerAttributeListener(OnAttributeChanged);	
	openTool.xulDoc.editorWindow = this;
	theWindow = document.getElementById("xulapp-theWindow");
	
	loadForm();
		//xulEditorWindowLauncher(xulapp, openTool.xulDoc);
		
	if (xulapp.widgetTreeEditor)
		xulapp.widgetTreeEditor.focus();
	else	
		xulapp.widgetTreeEditor = window.openDialog("chrome://xulapp/content/tools/xulEditor/widgetTreeEditor.xul", "widgetTreeEditor", "resizable=yes,chrome,titlebar",xulapp, openTool);
}

function OnWidgetSelected(nodeId, isSelected, augmentSelection) {
	//debug("OWS:" + srcNode.localName + ":" + isSelected);
	var elem = findByNodeId(nodeId)
	if (elem) {
		if (isSelected) 
			elem.setAttribute("xulapp-selected", "true");
		else	
			elem.removeAttribute("xulapp-selected");
	}		
}

function OnAttributeChanged(nodeId, attributeid, oldValue, newValue, originatingWindow) {
	if (originatingWindow == window) return;
	//debug("widget:" + srcNode.localName + " Attribute:" + attributeid + " has  changed - old:" + oldValue + ",new:" + newValue);
	var elem = findByNodeId(nodeId);
	if (elem) { // only deal with changes to visible/filtered elements.
		if (newValue)
			elem.setAttribute(attributeid, newValue);
		else
			elem.removeAttribute(attributeid);
	}
	
	if (attributeid == "title" && elem.localName == "window") {
		var win = document.getElementById("xulapp-xulEditor");
		win.setAttribute("title" , "XUL App - " +  newValue);
	}
}

function onfocus_window(event) {
	//debug("FOCUS");
	xulapp.currentDocument = openTool.xulDoc;
	if (xulapp.widgetTreeEditor 
		&& xulapp.widgetTreeEditor.xulDoc) {
			if (xulapp.currentDocument != xulapp.widgetTreeEditor.xulDoc) {
				if (xulapp.widgetTreeEditor.OnFormSelected) {
					xulapp.widgetTreeEditor.OnFormSelected(openTool.xulDoc);
				}	
		}
	}
}

function OnClick(event) {
	if (xulapp.widgetTreeEditor) {
		var selNode = event.target;
		var nodeId = selNode.getAttribute("xulapp-id");
		if (nodeId) {
			//debug("CLICK:" + event.target.localName + "SN:" + srcNode.localName);
			var augmentSelection = event.ctrlKey;
			if (!augmentSelection) {
				// clear previous selection
				openTool.xulDoc.clearSelection();
			}
			openTool.xulDoc.notifyWidgetSelected(nodeId, true, augmentSelection);
		}	
	}
	return false;
}

function updateDocument(srcNode, action, refNode) {
	switch (refNode.nodeType) {
	case NODE_TYPE_ELEMENT:	
		// some tags relating to event processing are ignored.
		if (refNode.localName in ignoreTags) return;
		break;
	case NODE_TYPE_COMMENT:
		return;
	}
	// brute force.
	loadForm();	
}


function loadForm() {
	//debug("loadForm");
	// clear old tree data.
	while (theWindow.hasChildNodes()) {
		theWindow.removeChild(theWindow.firstChild); 
	}
	xulDoc = openTool.xulDoc;
	if (!xulDoc)
		return;
	srcDOM = xulDoc.srcDOM;
	if (!srcDOM)
		return;
		
	loadKnownStyleSheets();
	// Add selected stylesheets.
	for (var node = srcDOM.firstChild; node; node=node.nextSibling) {
		if (node.nodeType != NODE_TYPE_PROCESSING_INSTRUCTION) 
			continue;
		if (node.target != "xml-stylesheet") 
			continue;
		var v = node.data.split(/\s+/);
		for (var i=0; i<v.length; i++) {
			if (v[i].indexOf("href=") != -1) {
				if (!isKnownStyleSheet(v[i].substring(5))) {
					var styleSheet = document.createProcessingInstruction("xml-stylesheet", node.data);
					document.insertBefore(styleSheet, document.documentElement);
				}
			}
		}
	}
	
	var documentElement = openTool.xulDoc.srcDOM.documentElement;
	
	// put id on the window element corresponding to top level item is xul document.
	theWindow.setAttribute("xulapp-id", xulDoc.getIdMapId(documentElement));
	try {
		//debug("docElem:" + documentElement);
		copySelectedNodes(theWindow, documentElement);
	}
	catch(e) {
		debug(e);
//		debug(getStackTrace());
	}

	// XXX there may be other window attributes which need copying.
	var attrs = ["orient", "width", "height"];
	for (var i=0; i< attrs.length; i++) {
		var attr = attrs[i];
		if (documentElement.hasAttribute(attr)) {
			theWindow.setAttribute(attr, documentElement.getAttribute(attr));
		}		
	}	
	// Special case the title need to be put on the main window.
	if (documentElement.hasAttribute("title")) {
		var win = document.getElementById("xulapp-xulEditor");
		win.setAttribute("title" , "XUL App - " +  documentElement.getAttribute("title"));
	}	

} 
function loadKnownStyleSheets() {
	styleSheets = document.styleSheets;
	for (var i=0; i<styleSheets.length; i++) {
		var styleSheet = styleSheets.item(i);
		var	cssStyleSheet = styleSheet.QueryInterface(Components.interfaces.nsIDOMCSSStyleSheet);
		if (cssStyleSheet) {
			knownStyleSheets[knownStyleSheets.length] = cssStyleSheet.href;
		}
	}
}

function isKnownStyleSheet(styleSheetName) {
	for (var i=0; i< knownStyleSheets.length; i++) {
		if (knownStyleSheets[i] == styleSheetName)
			return true;
	}
	return false;
}

// recursive function to selectively copy source nodes.
// <script> elements are ignored and event handling attributes are dropped.
// XXX for now, we strip all "on..." attributes. (Oh well!). 
function copySelectedNodes(parent, srcNode) {
	var children = srcNode.childNodes;
	for (var i=0; i<children.length; i++) {
		var childNode = children.item(i);
		if (childNode.nodeType != NODE_TYPE_ELEMENT) continue;
		if (childNode.localName in ignoreTags) continue;
		//debug("copySelectedNodes:" + childNode.localName);
		var newNode = cloneNode(childNode);
		parent.appendChild(newNode);
	
		if (childNode.hasChildNodes()) {
			copySelectedNodes(newNode, childNode);
		}
	}
}

// We need to suppress certain event handlers.
function cloneNode(srcNode) {
	var clone = document.createElement(srcNode.localName);
	var id = xulDoc.getIdMapId(srcNode);
	clone.setAttribute("xulapp-id", id);
	
	var widgetClass = "";
	if (srcNode.hasAttributes()) {
		var attrs = srcNode.attributes;
		for (var i=0; i < attrs.length; i++) {
			attr = attrs.item(i);
			if (attr.name.substr(0,2) != "on" && attr.name != "observes") {
				if (attr.name=="class")
					widgetClass = attr.value; // store for later use.
				else
					clone.setAttribute(attr.name, attr.value);
			}
		}
	}
	// add selectable class to support selection outline for widgets.
	if (widgetClass == "")
		clone.setAttribute("class", "xulapp-selectable");
	else	
		clone.setAttribute("class", widgetClass + " xulapp-selectable");

	return clone;	
}

function findByNodeId(nodeId) {
	elems = theWindow.getElementsByTagName("*");
	for (var i=0; i<elems.length; i++) {
		var elem = elems.item(i);
		if (elem.getAttribute("xulapp-id") == nodeId) {
			//debug("FOUND ELEMENT:" + elem.localName);
			return elem;
		}	
	}
	if (theWindow.getAttribute("xulapp-id") == nodeId)
		return theWindow;
	else	
		return null;
}


function onclose_window(event) {
	return openTool.xulDoc.mightSave(xulapp.getMsg("XULEDITOR.SaveDialogTitle"), xulapp.getMsg("XULEDITOR.SaveDialogMsg", openTool.xulDoc.path));
}

function onunload_window(event) {
	if (xulapp.widgetTreeEditor)
		xulapp.widgetTreeEditor.OnFormSelected(null);

	openTool.xulDoc.unregisterSelectionListener(OnWidgetSelected);
	openTool.xulDoc.unregisterAttributeListener(OnAttributeChanged);	
	openTool.xulDoc.editorWindow = null;
	openTool.xulDoc.close();
	openTool.close();
}
