/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is XulApp IDE.
 *
 * The Initial Developer of the Original Code is Synesis Software (USA) Inc.
 *

 * Portions created by the Initial Developer are Copyright (C) 2001-2005
 * Synesis Software (USA) Inc. the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * 	Peter Wilson, orignal author.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the LGPL or the GPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 *
 * ***** END LICENSE BLOCK ***** */
 
netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
var modelDoc;
var title;

// If no arguments are supplied we are re-opening an exiting view.
if (window.arguments) {
	modelDoc = window.arguments[0];
	title = window.arguments[1];
}

var xmlBrowser;
var xmlBrowserContent;
var xslDoc;


function OnLoad() {
	xmlBrowser = document.getElementById("xmlBrowser");
	xmlBrowserContent = xmlBrowser.contentDocument;
	
	var lblTitle =	document.getElementById("lblTitle");
	lblTitle.setAttribute("value",title);

	var dirPath = File.dirPath(document.location.href);
   	xslDoc = Utility.loadDOMFromURI("text/xml", dirPath + "/viewDOM.xsl");
	OnReload();
}

function OnReload() {
	// Tansform xml file to an xhtml document.
	var viewDoc = loadAndTransform(modelDoc,
							  xslDoc,
							  null);

	// Replace the dummy default-xjs.xhtml with the new document.							  
	var viewBodyElem = viewDoc.getElementsByTagName("body")[0];							  
	var viewBodyImported = xmlBrowserContent.importNode(viewBodyElem, true);
	
	var htmlElem = xmlBrowserContent.documentElement;
	var bodyElem = htmlElem.getElementsByTagName("body")[0];							  
	htmlElem.replaceChild(viewBodyImported, bodyElem);

}

function loadAndTransform(xmlDoc, xslDoc, params)
{
   	var xsltProc = new XSLTProcessor();
   	if (params) {
   		for (var i=0; i<params.length; i++) {
			xsltProc.setParameter("", params[i].name, params[i].value);
		}	
	}	
   	
   	xsltProc.importStylesheet(xslDoc);
   	
   	return xsltProc.transformToDocument(xmlDoc);
}

function OnUnload(event) {
}