/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is XulApp IDE.
 *
 * The Initial Developer of the Original Code is Synesis Software (USA) Inc.
 *

 * Portions created by the Initial Developer are Copyright (C) 2001-2005
 * Synesis Software (USA) Inc. the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * 	Peter Wilson, orignal author.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the LGPL or the GPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 *
 * ***** END LICENSE BLOCK ***** */
 
netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");

const MOSTRECENTFILES_MAX = 10;
const MOSTRECENTFILES_SEP = 0x07; // BEL
var DS = null;
var tree1;
var tree2;
var toolsPopup;
var toolsTemplate;

var xulapp = null;

function OnLoad() {
	xulapp = new XulApp();
	DS = new DirSortedDatasource();
	tree1 = document.getElementById("tree1");
	tree2 = document.getElementById("tree2");
	tree2.database.AddDataSource(DS);
	tree2.setAttribute("ref", "");
	
	toolsPopup = document.getElementById("toolsPopup");
	toolsTemplate = new XSLTemplate("toolsPopupTemplate", xulapp.tools);
	
	window.focus()
}

function OnUnload() {
	if (DS) {
		DS.RemoveObserver(DS);
	}
}

function addMostRecentFiles(projectFileURI, remove) {
	var win = document.getElementById("xulapp-main");
	var mrf = win.getAttribute("mostRecentFiles"); // Persisted file list.
	// Build new.
	var mrfArray = mrf.split(MOSTRECENTFILES_SEP); // entries delimited by a new line.
	// remove the file if it is already in the list;
	for (var i=0; i < mrfArray.length; i++) {
		if (mrfArray[i] == projectFileURI) {
			mrfArray.splice(i,1);
			break;
		}
	}
	// Add new entry and prune list to max length.
	if (!remove) {
		mrfArray.unshift(projectFileURI);
		while (mrfArray.length > MOSTRECENTFILES_MAX) 
			mrfArray.pop();
	}	
	win.setAttribute("mostRecentFiles", mrfArray.join(MOSTRECENTFILES_SEP));
}

function buildMostRecentFiles() {
	var win = document.getElementById("xulapp-main");
	var mrfStart = document.getElementById("mrf-start");
	var mrfEnd = document.getElementById("mrf-end");
	// remove old elements.
	while (mrfStart.nextSibling.getAttribute("id") != "mrf-end") {
		mrfStart.parentNode.removeChild(mrfStart.nextSibling);
	}
	if (document.getElementById("noProjectDisabled").getAttribute("disabled") == "false") {
		var mrf = win.getAttribute("mostRecentFiles"); // Persisted file list.
		// Build new.	
		var mrfArray = mrf.split(MOSTRECENTFILES_SEP); // entries delimited by a new line.
		var prevItem = mrfStart;
		for (var i=0; i < mrfArray.length; i++) {
			var projectFileURI = mrfArray[i];
			if (!projectFileURI)
				continue;
			var menuitem = document.createElement("menuitem");
			var projectFilePath = File.URLToPath(projectFileURI);
			menuitem.setAttribute("label",(i+1) + ". " + projectFilePath);
			if (projectFileURI.indexOf('"') == -1) { // Too bad file name contains a quote.
				menuitem.setAttribute("oncommand", 'xulapp.openProject("' + File.pathToURL(projectFilePath) + '")');
				mrfStart.parentNode.insertBefore(menuitem, mrfEnd);
			}	
		}
	}	
}

function onDblClickTree1(tree, columnName) {
	try {
		var row = tree.treeBoxObject.view.selection.currentIndex;
		var properties = Components.classes["@mozilla.org/supports-array;1"].createInstance(Components.interfaces.nsISupportsArray);
		tree.treeBoxObject.view.getCellProperties(row, columnName, properties);
		if (!properties) return;
		var fileURI = getPropertyValue(properties, "fileURI-");
		if (fileURI) 
			setTree2Ref(fileURI);
	}
	catch (e) {}
}
function onSelectTree2(tree, columnName) {
	var row = tree2.treeBoxObject.view.selection.currentIndex;	
	var properties = Components.classes["@mozilla.org/supports-array;1"].createInstance(Components.interfaces.nsISupportsArray);
	tree2.treeBoxObject.view.getCellProperties(row, "FileNameCol", properties);
	if (!properties)
		return;
	var extIcon = getPropertyValue(properties, "extIcon-");
}
function onDblClickTree2(tree, columnName) {
	try {
		var row = tree.treeBoxObject.view.selection.currentIndex;
		var properties = Components.classes["@mozilla.org/supports-array;1"].createInstance(Components.interfaces.nsISupportsArray);
		tree.treeBoxObject.view.getCellProperties(row, "FileNameCol", properties);
		if (!properties)
			return;
		var extIcon = getPropertyValue(properties, "extIcon-");
		var fileURI = getPropertyValue(properties, "fileURI-");
		if (extIcon == "dir") {
			setTree2Ref(fileURI);
		}
		else {
			// Open default tool for this extension.
			var extension = getPropertyValue(properties, "extension-");
			var toolId = getDefaultTool(extension);
			xulapp.openTool(toolId, fileURI, extension);

		}
	}
	catch (e) {}
}
function getDefaultTool(extension) {
	if (!extension)
		return "srcEditor";
	var xpathEvaluator = Components.classes["@mozilla.org/dom/xpath-evaluator;1"].createInstance(Components.interfaces.nsIDOMXPathEvaluator);
	//WARN: dont use document as basis for nsResolver - only an element or attribute will do.
	var nsResolver = xpathEvaluator.createNSResolver(xulapp.tools.documentElement);
	

	// Should be:
	// var xpath = '//tl:documenttype[@refid="' + extension + '"][@default]/parent::*/attribute::id'
	// but this returns an element not an attribute.
	//Note: extension comes with leading "." which needs to be stripped.
	var xpath = "//tl:documenttype[@refid='" + extension.substr(1) + "'][@default]/parent::*";
	var resultType = Components.interfaces.nsIDOMXPathResult.FIRST_ORDERED_NODE_TYPE;
	var elemList =  xpathEvaluator.evaluate(xpath, xulapp.tools, nsResolver, resultType, null);	
	var elem = elemList.singleNodeValue;
	if (!elem)
		return "srcEditor"; // Generic editor.
	else
		return elem.getAttribute("id");
}
function onToolsPopupShowing(event) {
	var row = tree2.treeBoxObject.view.selection.currentIndex;	
	var properties = Components.classes["@mozilla.org/supports-array;1"].createInstance(Components.interfaces.nsISupportsArray);
	tree2.treeBoxObject.view.getCellProperties(row, "FileNameCol", properties);
	if (!properties)
		return;
	var ext = getPropertyValue(properties, "extension-");
	if (!ext) 
		return; //TODO add menu items for directories.
	ext = ext.substr(1); // drop leading period.	
	toolsTemplate.setStringParam("doctypefilter", ext);
	toolsTemplate.build();
}
function onToolSelected(toolId) {
	var row = tree2.treeBoxObject.view.selection.currentIndex;	
	var properties = Components.classes["@mozilla.org/supports-array;1"].createInstance(Components.interfaces.nsISupportsArray);
	tree2.treeBoxObject.view.getCellProperties(row, "FileNameCol", properties);
	if (!properties)
		return;
	var fileURI = getPropertyValue(properties, "fileURI-");
	var extension = getPropertyValue(properties, "extension-");
	xulapp.openTool(toolId, fileURI, extension);
}

function setTree2Ref(uri) {
	tree2.setAttribute("ref", (uri || ""));
	enableCmdBack();
	if (uri)
		document.title = "Xul App - " + File.URLToPath(uri);
	else
		document.title = "Xul App";
}

/** Search properties nsISupportsArray for an nsIAtom which starts with the given property name. **/
function getPropertyValue(properties, propName) {
	for (var i=0; i< properties.Count(); i++) {
		var atom = properties.GetElementAt(i).QueryInterface(Components.interfaces.nsIAtom);
		var atomValue = atom.toString();
		if (atomValue.substr(0, propName.length) == propName)
			return atomValue.substr(propName.length);
	}
	return null;
}

function cmdBack() {
	var dirTop = tree1.getAttribute("ref");
	var dir = tree2.getAttribute("ref");
	
	if (dir != dirTop) {
		var file = new File(dir);
		dir = file.parent.URL;
	}
	setTree2Ref(dir);
}
function enableProject(uri) {
	var enable = (uri != null);
	document.getElementById("noProjectHidden").setAttribute("hidden", enable);
	document.getElementById("noProjectDisabled").setAttribute("disabled", enable);
	document.getElementById("aProjectHidden").setAttribute("hidden", !enable);
	document.getElementById("aProjectDisabled").setAttribute("disabled", !enable);
	tree1.setAttribute("ref",(uri || ""));
	setTree2Ref(uri)	
}
function enableCmdBack() {
	var dirTop = tree1.getAttribute("ref");
	var dir = tree2.getAttribute("ref");
	
	document.getElementById("cmd-back").setAttribute("disabled", (dir == dirTop)); 
}

function newProjectCallback(projectFileURI) {
	if (xulapp.project.openProject(projectFileURI)) {
		enableProject(xulapp.project.projectDirectoryURI);
		addMostRecentFiles(xulapp.project.projectFileURI);
   }
}

//TODO get this stuff outa here!
function XulApp () {
// Properties:
	this.mainWindow = window;
	this.openTools = new OpenTools(this);
	this.openDocuments = new OpenDocuments(this);
	this.tools = Utility.loadDOMFromURI("text/xml", "chrome://xulapp/content/resource/tools.xml");
	this.documentTypes = Utility.loadDOMFromURI("text/xml", "chrome://xulapp/content/resource/documentTypes.xml");
	this.toolboxTools = Utility.loadDOMFromURI("text/xml", "chrome://xulapp/content/resource/toolboxTools.xml");
	//TODO widgets and widgetAttributes should not be loaded here.
	this.widgets = Utility.loadDOMFromURI("text/xml", "chrome://xulapp/content/resource/widgets.xml");
	this.widgetAttributes = Utility.loadDOMFromURI("text/xml", "chrome://xulapp/content/resource/widgetAttributes.xml");	
	this.attributeTypes = Utility.loadDOMFromURI("text/xml", "chrome://xulapp/content/resource/attributeTypes.xml");		
	//TODO move towidgetbar.js

	this.toolbars = Utility.loadDOMFromURI("text/xml", "chrome://xulapp/content/resource/toolbars.xml");
	this.schemas = new Schemas();
	this.project = new Project();
	this.widgetbar = null;
	this.sourceEditor = null;	
	this.widgetTreeEditor = null;	
	this.currentDocument = null;
	this.nextWidgetId = new Object(); // next number assigned by widget/property name.
	this.dropData = null;
	this.boxAcceptsChildren = null;
	this.xulAppMsg = new StringBundle("chrome://xulapp/locale/xulapp.msg");
	this.promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].
					getService(Components.interfaces.nsIPromptService);
}


XulApp.prototype.toString = function() {
	return "XulApp object";
}

XulApp.prototype.newProject = function(event) {
	window.openDialog("chrome://xulapp/content/newProject.xul", "newProject", "chrome,titlebar,dependent=yes,dialog=yes.modal",xulapp, newProjectCallback);
}

XulApp.prototype.openProject = function(projectFileURI) {
	if (projectFileURI) {
		var projectFile = new File(projectFileURI);
		if (!projectFile.exists()) {
			alert(xulapp.getMsg("XULAPP.ProjectFileNotFound", projectFileURI));
			addMostRecentFiles(projectFileURI, true); // remove entry from mrf.				
		}
	}	
	if (xulapp.project.openProject(projectFileURI)) {
		enableProject(xulapp.project.projectDirectoryURI);	
		addMostRecentFiles(this.project.projectFileURI);		
   }
   else
	  	return;
	// Check project has chrome setup:
	try {
		var aFile = new File(xulapp.project.chromePrefix + "content/");
		if (aFile.path.substr(0,9) == "resource:") {
			alert(xulapp.getMsg("XULAPP.ChromeNotRegistered",xulapp.project.projectName));
		}
	}
	catch (e) {
		alert(xulapp.getMsg("XULAPP.ChromeNotRegistered",xulapp.project.projectName));
	}
}

XulApp.prototype.openTool = function(toolId, fileURI, extension) {
	this.openTools.openTool(toolId, fileURI, extension);
}

XulApp.prototype.newFile = function(toolId, fileType) {
	switch (fileType) {
	case ".xul":
		xulapp.openTool(toolId, "chrome://xulapp/content/resource/defaultform.xul", ".xul");
		break;
	case ".xjs":	
		xulapp.openTool(toolId, "chrome://xulapp/content/resource/default.xjs", ".xul");
		break;
	default:	
		alert("Create new " + fileType.substr(1) +  " file not yet implemented.");			
	}
}
XulApp.prototype.closeProject = function(event) {
	if (xulapp.openTools.closeAll()) {
		enableProject(null);	
		xulapp.project = new Project();
		return true;
	}
	return false;
}

XulApp.prototype.exitProject = function(event) {
	if (this.closeProject(event))
		window.close();
}

XulApp.prototype.showProject = function(event) {
	window.focus();
}

XulApp.prototype.openFile = function() {
}

XulApp.prototype.runFile = function(event) {
}

/** you may pass aditional arguments for message parameter substitution. */
XulApp.prototype.getMsg = function(name) {
	return this.xulAppMsg.getString(arguments);
}

// required to run Venkman.
function toOpenWindowByType( inType, uri )
{
	var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();

	var	windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);

	var topWindow = windowManagerInterface.getMostRecentWindow( inType );
	
	if ( topWindow )
		topWindow.focus();
	else
		window.open(uri, "_blank", "chrome,extrachrome,menubar,resizable,scrollbars,status,toolbar");
}


